#include <geodata.h>
#include <geodata_private.h>
#if defined(sparc)
#define STRING char
#define CSTR(x) (x)
#elif defined(vax)
typedef struct { short len, filler; char *str } fstring;
#define STRING fstring
#define CSTR(x) (x->str)
#endif

/* function at line 9374 */
#if defined(sparc)
#define GI_CREATE_DATA_SET gi_create_data_set_
#endif
GI_CREATE_DATA_SET (farg, label)
int *farg;
STRING *label;
{
    *farg = GI_create_data_set (CSTR(label));
}

/* function at line 9402 */
#if defined(sparc)
#define GI_DELETE_DATA_SET gi_delete_data_set_
#endif
GI_DELETE_DATA_SET (dsid)
int *dsid;
{
    GI_delete_data_set (*dsid);
}

/* function at line 9489 */
#if defined(sparc)
#define GI_SET_DATA_DETAIL gi_set_data_detail_
#endif
GI_SET_DATA_DETAIL (dsid, detail)
int *dsid;
STRING *detail;
{
    GI_set_data_detail (*dsid, CSTR(detail));
}

/* function at line 9564 */
#if defined(sparc)
#define GI_SET_DATA_TYPE gi_set_data_type_
#endif
GI_SET_DATA_TYPE (dsid, code, origin, extent)
int *dsid;
int *code;
float *origin;
float *extent;
{
    GI_set_data_type (*dsid, (short)*code, origin, extent);
}

/* function at line 9611 */
#if defined(sparc)
#define GI_SET_3D_CARTESIAN_COORDINATES gi_set_3d_cartesian_coordinates_
#endif
GI_SET_3D_CARTESIAN_COORDINATES (dsid, units)
int *dsid;
int *units;
{
    GI_set_3d_cartesian_coordinates (*dsid, *units);
}

/* function at line 9678 */
#if defined(sparc)
#define GI_SET_ANGULAR_COORDINATES gi_set_angular_coordinates_
#endif
GI_SET_ANGULAR_COORDINATES (dsid, units_1, units_2, reference_surface)
int *dsid;
int *units_1;
int *units_2;
int *reference_surface;
{
    GI_set_angular_coordinates (*dsid, *units_1, *units_2, *reference_surface);
}

/* function at line 9763 */
#if defined(sparc)
#define GI_SET_2D_CARTESIAN_COORDINATES gi_set_2d_cartesian_coordinates_
#endif
GI_SET_2D_CARTESIAN_COORDINATES (dsid, units, r, nv, y)
int *dsid;
int *units;
float *r;
float *nv;
float *y;
{
    GI_set_2d_cartesian_coordinates (*dsid, *units, r, nv, y);
}

/* function at line 9817 */
#if defined(sparc)
#define GI_SET_MAP_COORDINATES gi_set_map_coordinates_
#endif
GI_SET_MAP_COORDINATES (dsid, proj_info)
int *dsid;
int *proj_info;
{
    GI_set_map_coordinates (*dsid, *proj_info);
}

/* function at line 9834 */
#if defined(sparc)
#define GI_NP2 gi_np2_
#endif
GI_NP2 (farg, n)
int *farg;
int *n;
{
    *farg = GI_np2 (*n);
}

/* function at line 9901 */
#if defined(sparc)
#define GI_SET_FE_DATA gi_set_fe_data_
#endif
GI_SET_FE_DATA (dsid, data, rank, shape)
int *dsid;
float *data;
int *rank;
int *shape;
{
    GI_set_fe_data (*dsid, data, *rank, shape);
}

/* function at line 9950 */
#if defined(sparc)
#define CGI_SET_CM_DATA cgi_set_cm_data_
#endif
CGI_SET_CM_DATA (dsid, values, context, vpset)
int *dsid;
int *values;
int *context;
int *vpset;
{
  GD_data_desc *desc;
  desc=(GD_data_desc *)GB_get_object (*dsid);
  desc->fortran_data_flag=1;
  desc->fortran_geometry=CM_vp_set_geometry(*vpset);
  GI_set_cm_data (*dsid, *values, *context);
  desc->rank= CM_geometry_rank(CM_vp_set_geometry(CM_field_vp_set(*values)));
  desc->rank--;
}

/* function at line 9983 */
#if defined(sparc)
#define GI_SET_REF_DATA gi_set_ref_data_
#endif
GI_SET_REF_DATA (dsid)
int *dsid;
{
    GI_set_ref_data (*dsid);
}

/* function at line 10017 */
#if defined(sparc)
#define GI_GET_DATA_DETAIL gi_get_data_detail_
#endif
GI_GET_DATA_DETAIL (farg, dsid)
STRING *farg;
int *dsid;
{
    strcpy(CSTR(farg), GI_get_data_detail (*dsid));
}

/* function at line 10035 */
#if defined(sparc)
#define GI_GET_DATA_ID gi_get_data_id_
#endif
GI_GET_DATA_ID (farg, label)
int *farg;
STRING *label;
{
    *farg = GI_get_data_id (CSTR(label));
}

/* function at line 10064 */
#if defined(sparc)
#define GI_GET_DATA_TYPE gi_get_data_type_
#endif
GI_GET_DATA_TYPE (farg, dsid)
int *farg;
int *dsid;
{
    *farg = GI_get_data_type (*dsid);
}

/* function at line 10104 */
#if defined(sparc)
#define GI_GET_MESH_INFO gi_get_mesh_info_
#endif
GI_GET_MESH_INFO (dsid, origin, extent)
int *dsid;
float *origin;
float *extent;
{
    GI_get_mesh_info (*dsid, origin, extent);
}

/* function at line 10134 */
#if defined(sparc)
#define GI_GET_DATA_COORD_SYSTEM gi_get_data_coord_system_
#endif
GI_GET_DATA_COORD_SYSTEM (farg, dsid)
int *farg;
int *dsid;
{
    *farg = GI_get_data_coord_system (*dsid);
}

/* function at line 10189 */
#if defined(sparc)
#define GI_GET_ANGULAR_INFO gi_get_angular_info_
#endif
GI_GET_ANGULAR_INFO (dsid, units_1, units_2, reference_surface)
int *dsid;
int *units_1;
int *units_2;
int *reference_surface;
{
    GI_get_angular_info (*dsid, units_1, units_2, reference_surface);
}

/* function at line 10230 */
#if defined(sparc)
#define GI_GET_3D_CARTESIAN_INFO gi_get_3d_cartesian_info_
#endif
GI_GET_3D_CARTESIAN_INFO (dsid, units)
int *dsid;
int *units;
{
    GI_get_3d_cartesian_info (*dsid, units);
}

/* function at line 10276 */
#if defined(sparc)
#define GI_GET_MAP_INFO gi_get_map_info_
#endif
GI_GET_MAP_INFO (dsid, proj_code, param)
int *dsid;
int *proj_code;
float *param;
{
    GI_get_map_info (*dsid, proj_code, param);
}

/* function at line 10355 */
#if defined(sparc)
#define GI_GET_2D_CARTESIAN_INFO gi_get_2d_cartesian_info_
#endif
GI_GET_2D_CARTESIAN_INFO (dsid, units, r, nv, y)
int *dsid;
int *units;
float *r;
float *nv;
float *y;
{
    GI_get_2d_cartesian_info (*dsid, units, r, nv, y);
}

/* function at line 10393 */
#if defined(sparc)
#define GI_GET_DATA_LOCATION gi_get_data_location_
#endif
GI_GET_DATA_LOCATION (farg, dsid)
int *farg;
int *dsid;
{
    *farg = GI_get_data_location (*dsid);
}

/* function at line 10439 */
#if defined(sparc)
#define GI_GET_FE_INFO gi_get_fe_info_
#endif
GI_GET_FE_INFO (dsid, data, rank, shape)
int *dsid;
float **data;
int *rank;
int *shape;
{
    GI_get_fe_info (*dsid, *data, rank, shape);
}

/* function at line 10480 */
#if defined(sparc)
#define GI_GET_CM_INFO gi_get_cm_info_
#endif
GI_GET_CM_INFO (dsid, value_id, context_id)
int *dsid;
int *value_id;
int *context_id;
{
    GI_get_cm_info (*dsid, value_id, context_id);
}

/* function at line 11917 */
#if defined(sparc)
#define GI_CREATE_DISPLAY gi_create_display_
#endif
GI_CREATE_DISPLAY (farg, label, name, type, width, height)
int *farg;
STRING *label;
STRING *name;
int *type;
int *width;
int *height;
{
    *farg = GI_create_display (CSTR(label), CSTR(name), *type, *width, *height);
}

/* function at line 11938 */
#if defined(sparc)
#define GI_GET_DISPLAY_ID gi_get_display_id_
#endif
GI_GET_DISPLAY_ID (farg, label)
int *farg;
STRING *label;
{
    *farg = GI_get_display_id (CSTR(label));
}

/* function at line 11966 */
#if defined(sparc)
#define GI_CREATE_X_DISPLAY gi_create_x_display_
#endif
GI_CREATE_X_DISPLAY (farg, name, window)
int *farg;
STRING *name;
int *window;
{
    *farg = GI_create_X_display (CSTR(name), *window);
}

/* function at line 11995 */
#if defined(sparc)
#define GI_GET_DISPLAY_SIZE gi_get_display_size_
#endif
GI_GET_DISPLAY_SIZE (display, width, height)
int *display;
int *width;
int *height;
{
    GI_get_display_size (*display, width, height);
}

/* function at line 13770 */
#if defined(sparc)
#define GMOD gmod_
#endif
GMOD (farg, x, y)
double *farg;
double *x;
double *y;
{
    *farg = gmod (*x, *y);
}

/* function at line 13812 */
#if defined(sparc)
#define GI_GET_INSTANCE_INTERNAL gi_get_instance_internal_
#endif
GI_GET_INSTANCE_INTERNAL (farg, place, type, id)
int *farg;
STRING *place;
int *type;
int *id;
{
    *farg = GI_get_instance_internal (CSTR(place), *type, *id);
}

/* function at line 13855 */
#if defined(sparc)
#define GI_SCALED_GEOGRAPHICS gi_scaled_geographics_
#endif
GI_SCALED_GEOGRAPHICS (farg)
int *farg;
{
    *farg = GI_scaled_geographics ();
}

/* function at line 13898 */
#if defined(sparc)
#define GI_MILLER gi_miller_
#endif
GI_MILLER (farg)
int *farg;
{
    *farg = GI_miller ();
}

/* function at line 13954 */
#if defined(sparc)
#define GI_GNOMONIC gi_gnomonic_
#endif
GI_GNOMONIC (farg, lat, lon)
int *farg;
float *lat;
float *lon;
{
    *farg = GI_gnomonic (*lat, *lon);
}

/* function at line 14001 */
#if defined(sparc)
#define GI_MOLLWEIDE gi_mollweide_
#endif
GI_MOLLWEIDE (farg, lon)
int *farg;
float *lon;
{
    *farg = GI_mollweide (*lon);
}

/* function at line 14043 */
#if defined(sparc)
#define GI_NP_STEREO gi_np_stereo_
#endif
GI_NP_STEREO (farg)
int *farg;
{
    *farg = GI_np_stereo ();
}

/* function at line 14084 */
#if defined(sparc)
#define GI_SP_STEREO gi_sp_stereo_
#endif
GI_SP_STEREO (farg)
int *farg;
{
    *farg = GI_sp_stereo ();
}

/* function at line 14170 */
#if defined(sparc)
#define GI_LAMBERT gi_lambert_
#endif
GI_LAMBERT (farg, std_lat_1, std_lat_2, n_lat, s_lat, e_lon, w_lon)
int *farg;
float *std_lat_1;
float *std_lat_2;
float *n_lat;
float *s_lat;
float *e_lon;
float *w_lon;
{
    *farg = GI_lambert (*std_lat_1, *std_lat_2, *n_lat, *s_lat, *e_lon, *w_lon);
}

/* function at line 14255 */
#if defined(sparc)
#define GI_GLOBE_VIEW gi_globe_view_
#endif
GI_GLOBE_VIEW (farg, lat, lon, alt, units, gamma, omega)
int *farg;
float *lat;
float *lon;
float *alt;
int *units;
float *gamma;
float *omega;
{
    *farg = GI_globe_view (*lat, *lon, *alt, *units, *gamma, *omega);
}

/* function at line 14318 */
#if defined(sparc)
#define GI_GENERAL_PERSPECTIVE gi_general_perspective_
#endif
GI_GENERAL_PERSPECTIVE (farg, x1, y1, z1, x2, y2, z2, x_up, y_up, z_up, fov, hither, yon)
int *farg;
float *x1;
float *y1;
float *z1;
float *x2;
float *y2;
float *z2;
float *x_up;
float *y_up;
float *z_up;
float *fov;
float *hither;
float *yon;
{
    *farg = GI_general_perspective (*x1, *y1, *z1, *x2, *y2, *z2, *x_up, *y_up, *z_up, *fov, *hither, *yon);
}

/* function at line 14360 */
#if defined(sparc)
#define GI_NONE gi_none_
#endif
GI_NONE (farg)
int *farg;
{
    *farg = GI_none ();
}

/* function at line 15614 */
#if defined(sparc)
#define GI_INIT gi_init_
#endif
GI_INIT (user_file)
STRING *user_file;
{
    GI_init (CSTR(user_file));
}

/* function at line 17005 */
#if defined(sparc)
#define GI_GET_REP_INTERNAL gi_get_rep_internal_
#endif
GI_GET_REP_INTERNAL (farg, place, id)
int *farg;
STRING *place;
int *id;
{
    *farg = GI_get_rep_internal (CSTR(place), *id);
}

/* function at line 17026 */
#if defined(sparc)
#define GI_GET_SYMBOL_ID gi_get_symbol_id_
#endif
GI_GET_SYMBOL_ID (farg, label)
int *farg;
STRING *label;
{
    *farg = GI_get_symbol_id (CSTR(label));
}

/* function at line 17048 */
#if defined(sparc)
#define GI_GET_REPRESENTATION_ID gi_get_representation_id_
#endif
GI_GET_REPRESENTATION_ID (farg, label)
int *farg;
STRING *label;
{
    *farg = GI_get_representation_id (CSTR(label));
}

/* function at line 17115 */
#if defined(sparc)
#define GI_DELETE_REPRESENTATION gi_delete_representation_
#endif
GI_DELETE_REPRESENTATION (rep_id)
int *rep_id;
{
    GI_delete_representation (*rep_id);
}

/* function at line 17143 */
#if defined(sparc)
#define GI_GET_REPRESENTATION_REP_CODE gi_get_representation_rep_code_
#endif
GI_GET_REPRESENTATION_REP_CODE (farg, rep_id)
int *farg;
int *rep_id;
{
    *farg = GI_get_representation_rep_code (*rep_id);
}

/* function at line 17172 */
#if defined(sparc)
#define GI_SET_REPRESENTATION_REP_CODE gi_set_representation_rep_code_
#endif
GI_SET_REPRESENTATION_REP_CODE (rep_id, rep_code)
int *rep_id;
int *rep_code;
{
    GI_set_representation_rep_code (*rep_id, *rep_code);
}

/* function at line 17200 */
#if defined(sparc)
#define GI_GET_REPRESENTATION_TRANSLUCENCY gi_get_representation_translucency_
#endif
GI_GET_REPRESENTATION_TRANSLUCENCY (farg, rep_id)
int *farg;
int *rep_id;
{
    *farg = GI_get_representation_translucency (*rep_id);
}

/* function at line 17229 */
#if defined(sparc)
#define GI_SET_REPRESENTATION_TRANSLUCENCY gi_set_representation_translucency_
#endif
GI_SET_REPRESENTATION_TRANSLUCENCY (rep_id, translucency)
int *rep_id;
int *translucency;
{
    GI_set_representation_translucency (*rep_id, *translucency);
}

/* function at line 17257 */
#if defined(sparc)
#define GI_GET_REPRESENTATION_WHAT_VARIES gi_get_representation_what_varies_
#endif
GI_GET_REPRESENTATION_WHAT_VARIES (farg, rep_id)
int *farg;
int *rep_id;
{
    *farg = GI_get_representation_what_varies (*rep_id);
}

/* function at line 17286 */
#if defined(sparc)
#define GI_SET_REPRESENTATION_WHAT_VARIES gi_set_representation_what_varies_
#endif
GI_SET_REPRESENTATION_WHAT_VARIES (rep_id, what_varies)
int *rep_id;
int *what_varies;
{
    GI_set_representation_what_varies (*rep_id, *what_varies);
}

/* function at line 17344 */
#if defined(sparc)
#define GI_GET_TABLE_T gi_get_table_t_
#endif
GI_GET_TABLE_T (farg, place, rep_id, value, previous, use_epsilon)
int *farg;
STRING *place;
int *rep_id;
float *value;
int ***previous;
int *use_epsilon;
{
    *farg = GI_get_table_t (CSTR(place), *rep_id, *value, *previous, *use_epsilon);
}

/* function at line 17395 */
#if defined(sparc)
#define GI_GET_TABLE_VALUES gi_get_table_values_
#endif
GI_GET_TABLE_VALUES (farg, rep_id, values, size)
int *farg;
int *rep_id;
float *values;
int *size;
{
    *farg = GI_get_table_values (*rep_id, values, *size);
}

/* function at line 17480 */
#if defined(sparc)
#define GI_DELETE_TABLE_VALUE gi_delete_table_value_
#endif
GI_DELETE_TABLE_VALUE (rep_id, value)
int *rep_id;
float *value;
{
    GI_delete_table_value (*rep_id, *value);
}

/* function at line 17514 */
#if defined(sparc)
#define GI_GET_TABLE_COLOR gi_get_table_color_
#endif
GI_GET_TABLE_COLOR (rep_id, value, color)
int *rep_id;
float *value;
int *color;
{
    GI_get_table_color (*rep_id, *value, color);
}

/* function at line 17549 */
#if defined(sparc)
#define GI_SET_TABLE_COLOR gi_set_table_color_
#endif
GI_SET_TABLE_COLOR (rep_id, value, color)
int *rep_id;
float *value;
int *color;
{
    GI_set_table_color (*rep_id, *value, color);
}

/* function at line 17578 */
#if defined(sparc)
#define GI_GET_TABLE_DISCRETE gi_get_table_discrete_
#endif
GI_GET_TABLE_DISCRETE (farg, rep_id, value)
int *farg;
int *rep_id;
float *value;
{
    *farg = GI_get_table_discrete (*rep_id, *value);
}

/* function at line 17611 */
#if defined(sparc)
#define GI_SET_TABLE_DISCRETE gi_set_table_discrete_
#endif
GI_SET_TABLE_DISCRETE (rep_id, value, discrete_id)
int *rep_id;
float *value;
int *discrete_id;
{
    GI_set_table_discrete (*rep_id, *value, *discrete_id);
}

/* function at line 17640 */
#if defined(sparc)
#define GI_GET_TABLE_SCALE gi_get_table_scale_
#endif
GI_GET_TABLE_SCALE (farg, rep_id, value)
float *farg;
int *rep_id;
float *value;
{
    *farg = GI_get_table_scale (*rep_id, *value);
}

/* function at line 17678 */
#if defined(sparc)
#define GI_SET_TABLE_SCALE gi_set_table_scale_
#endif
GI_SET_TABLE_SCALE (rep_id, value, scale)
int *rep_id;
float *value;
float *scale;
{
    GI_set_table_scale (*rep_id, *value, *scale);
}

/* function at line 17707 */
#if defined(sparc)
#define GI_GET_TABLE_ROTATION gi_get_table_rotation_
#endif
GI_GET_TABLE_ROTATION (farg, rep_id, value)
float *farg;
int *rep_id;
float *value;
{
    *farg = GI_get_table_rotation (*rep_id, *value);
}

/* function at line 17738 */
#if defined(sparc)
#define GI_SET_TABLE_ROTATION gi_set_table_rotation_
#endif
GI_SET_TABLE_ROTATION (rep_id, value, rotation)
int *rep_id;
float *value;
float *rotation;
{
    GI_set_table_rotation (*rep_id, *value, *rotation);
}

/* function at line 19123 */
#if defined(sparc)
#define GI_GET_SCENE_INTERNAL gi_get_scene_internal_
#endif
GI_GET_SCENE_INTERNAL (farg, place, id)
int *farg;
STRING *place;
int *id;
{
    *farg = GI_get_scene_internal (CSTR(place), *id);
}

/* function at line 19144 */
#if defined(sparc)
#define GI_GET_SCENE_ID gi_get_scene_id_
#endif
GI_GET_SCENE_ID (farg, label)
int *farg;
STRING *label;
{
    *farg = GI_get_scene_id (CSTR(label));
}

/* function at line 19170 */
#if defined(sparc)
#define GI_CREATE_SCENE gi_create_scene_
#endif
GI_CREATE_SCENE (farg, label)
int *farg;
STRING *label;
{
    *farg = GI_create_scene (CSTR(label));
}

/* function at line 19192 */
#if defined(sparc)
#define GI_DELETE_SCENE gi_delete_scene_
#endif
GI_DELETE_SCENE (scene_id)
int *scene_id;
{
    GI_delete_scene (*scene_id);
}

/* function at line 19215 */
#if defined(sparc)
#define GI_UPDATE_SCENE gi_update_scene_
#endif
GI_UPDATE_SCENE (scene_id)
int *scene_id;
{
    GI_update_scene (*scene_id);
}

/* function at line 19244 */
#if defined(sparc)
#define GI_DISPLAY_SCENE gi_display_scene_
#endif
GI_DISPLAY_SCENE (display, scene_id, x_offset, y_offset)
int *display;
int *scene_id;
int *x_offset;
int *y_offset;
{
    GI_display_scene (*display, *scene_id, *x_offset, *y_offset);
}

/* function at line 19270 */
#if defined(sparc)
#define GI_GET_SCENE_PROJECTION gi_get_scene_projection_
#endif
GI_GET_SCENE_PROJECTION (farg, scene_id)
int *farg;
int *scene_id;
{
    *farg = GI_get_scene_projection (*scene_id);
}

/* function at line 19304 */
#if defined(sparc)
#define GI_SET_SCENE_PROJECTION gi_set_scene_projection_
#endif
GI_SET_SCENE_PROJECTION (scene_id, projection)
int *scene_id;
int *projection;
{
    GI_set_scene_projection (*scene_id, *projection);
}

/* function at line 19334 */
#if defined(sparc)
#define GI_GET_SCENE_PROJECTION_PARAMS gi_get_scene_projection_params_
#endif
GI_GET_SCENE_PROJECTION_PARAMS (scene_id, parameters)
int *scene_id;
float *parameters;
{
    GI_get_scene_projection_params (*scene_id, parameters);
}

/* function at line 19365 */
#if defined(sparc)
#define GI_SET_SCENE_PROJECTION_PARAMS gi_set_scene_projection_params_
#endif
GI_SET_SCENE_PROJECTION_PARAMS (scene_id, parameters)
int *scene_id;
float *parameters;
{
    GI_set_scene_projection_params (*scene_id, parameters);
}

/* function at line 19403 */
#if defined(sparc)
#define GI_GET_SCENE_PROJECTION_PARAMETER gi_get_scene_projection_parameter_
#endif
GI_GET_SCENE_PROJECTION_PARAMETER (farg, scene_id, index)
float *farg;
int *scene_id;
int *index;
{
    *farg = GI_get_scene_projection_parameter (*scene_id, *index);
}

/* function at line 19441 */
#if defined(sparc)
#define GI_SET_SCENE_PROJECTION_PARAMETER gi_set_scene_projection_parameter_
#endif
GI_SET_SCENE_PROJECTION_PARAMETER (scene_id, index, value)
int *scene_id;
int *index;
float *value;
{
    GI_set_scene_projection_parameter (*scene_id, *index, *value);
}

/* function at line 19486 */
#if defined(sparc)
#define GI_ADD_SCENE_DATA gi_add_scene_data_
#endif
GI_ADD_SCENE_DATA (scene_id, rep_id, data_id, priority)
int *scene_id;
int *rep_id;
int *data_id;
int *priority;
{
    GI_add_scene_data (*scene_id, *rep_id, *data_id, *priority);
}

/* function at line 19539 */
#if defined(sparc)
#define GI_DELETE_SCENE_DATA gi_delete_scene_data_
#endif
GI_DELETE_SCENE_DATA (scene_id, rep_id, data_id)
int *scene_id;
int *rep_id;
int *data_id;
{
    GI_delete_scene_data (*scene_id, *rep_id, *data_id);
}

/* function at line 19578 */
#if defined(sparc)
#define GI_RESIZE_SCENE gi_resize_scene_
#endif
GI_RESIZE_SCENE (scene_id, width, height)
int *scene_id;
int *width;
int *height;
{
    GI_resize_scene (*scene_id, *width, *height);
}

/* function at line 19604 */
#if defined(sparc)
#define GI_GET_SCENE_WIDTH gi_get_scene_width_
#endif
GI_GET_SCENE_WIDTH (farg, scene_id)
int *farg;
int *scene_id;
{
    *farg = GI_get_scene_width (*scene_id);
}

/* function at line 19639 */
#if defined(sparc)
#define GI_SET_SCENE_WIDTH gi_set_scene_width_
#endif
GI_SET_SCENE_WIDTH (scene_id, width)
int *scene_id;
int *width;
{
    GI_set_scene_width (*scene_id, *width);
}

/* function at line 19666 */
#if defined(sparc)
#define GI_GET_SCENE_HEIGHT gi_get_scene_height_
#endif
GI_GET_SCENE_HEIGHT (farg, scene_id)
int *farg;
int *scene_id;
{
    *farg = GI_get_scene_height (*scene_id);
}

/* function at line 19701 */
#if defined(sparc)
#define GI_SET_SCENE_HEIGHT gi_set_scene_height_
#endif
GI_SET_SCENE_HEIGHT (scene_id, height)
int *scene_id;
int *height;
{
    GI_set_scene_height (*scene_id, *height);
}

/* function at line 19728 */
#if defined(sparc)
#define GI_GET_SCENE_ZOOM gi_get_scene_zoom_
#endif
GI_GET_SCENE_ZOOM (farg, scene_id)
int *farg;
int *scene_id;
{
    *farg = GI_get_scene_zoom (*scene_id);
}

/* function at line 19763 */
#if defined(sparc)
#define GI_SET_SCENE_ZOOM gi_set_scene_zoom_
#endif
GI_SET_SCENE_ZOOM (scene_id, zoom)
int *scene_id;
int *zoom;
{
    GI_set_scene_zoom (*scene_id, *zoom);
}

/* function at line 19793 */
#if defined(sparc)
#define GI_GET_SCENE_CENTER gi_get_scene_center_
#endif
GI_GET_SCENE_CENTER (scene_id, center)
int *scene_id;
float *center;
{
    GI_get_scene_center (*scene_id, center);
}

/* function at line 19836 */
#if defined(sparc)
#define GI_SET_SCENE_CENTER gi_set_scene_center_
#endif
GI_SET_SCENE_CENTER (scene_id, center)
int *scene_id;
float *center;
{
    GI_set_scene_center (*scene_id, center);
}

/* function at line 19867 */
#if defined(sparc)
#define GI_GET_SCENE_BACKGROUND gi_get_scene_background_
#endif
GI_GET_SCENE_BACKGROUND (scene_id, background)
int *scene_id;
int *background;
{
    GI_get_scene_background (*scene_id, background);
}

/* function at line 19910 */
#if defined(sparc)
#define GI_SET_SCENE_BACKGROUND gi_set_scene_background_
#endif
GI_SET_SCENE_BACKGROUND (scene_id, background)
int *scene_id;
int *background;
{
    GI_set_scene_background (*scene_id, background);
}

/* function at line 22255 */
#if defined(sparc)
#define GI_XTOOL_INIT gi_xtool_init_
#endif
GI_XTOOL_INIT (display, hostname, initialization)
STRING *display;
STRING *hostname;
STRING *initialization;
{
    GI_xtool_init (CSTR(display), CSTR(hostname), CSTR(initialization));
}

/* function at line 22262 */
#if defined(sparc)
#define GI_XTOOL_STEP gi_xtool_step_
#endif
GI_XTOOL_STEP ()
{
    GI_xtool_step ();
}

/* function at line 22273 */
#if defined(sparc)
#define GI_KILL_XTOOL gi_kill_xtool_
#endif
GI_KILL_XTOOL ()
{
    GI_kill_xtool ();
}

