#include <geodata.h>
#include <geodata_private.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/param.h>
#include <fcntl.h>
  
static FILE *xtool_in;
static FILE *xtool_out;
static int in_sockets[2];
static int out_sockets[2];
int Xtool_Remote_Child_PID=0;

#ifndef GEODATA_XTOOL
/*#define GEODATA_XTOOL "/afs/cmf/geodata/@sys/lib/xtool"*/
#define GEODATA_XTOOL "/afs/cmf/users/djones/geo/lib/xtool"
#endif

void GI_xtool_init(display,hostname,initialization)
     char *display;
     char *hostname;
     char *initialization;
{
  char *real_display;
  char temp[GD_FILE_NAME_LENGTH];

  if (display == 0) real_display = (char *)getenv ("DISPLAY");
  else real_display=display;

  pipe (in_sockets);
  pipe (out_sockets);
  
  xtool_in = fdopen (in_sockets[0],"r");
  xtool_out = fdopen (out_sockets[1],"w");
  
  if (hostname)strcpy(temp,hostname);
  else gethostname(temp,GD_FILE_NAME_LENGTH);
  Xtool_Remote_Child_PID=fork();
  fprintf(stderr,"Xtool_Remote_Child_PID=%d\n",Xtool_Remote_Child_PID);
  if (!Xtool_Remote_Child_PID){
    dup2(in_sockets[1],1);
    dup2(out_sockets[0],0);

    if (!hostname)
      execlp(GEODATA_XTOOL,"-display",real_display,0);
    else
      execlp("/usr/ucb/rsh","rsh",temp,GEODATA_XTOOL,"-display",
	     real_display,0);
  } 
  if (initialization){
    fprintf (xtool_out,"(include include-foo (file \"%s\"))\n",
#ifdef sparc	  
	     realpath(initialization,temp) ? temp : initialization);
#else 
             initialization);
#endif
  }
  fprintf (xtool_out,"(handshake handshake-foo)");
  fflush(xtool_out);
}

void GI_xtool_step()
{
  fprintf (xtool_out,"(handshake handshake-foo)");
  fflush (xtool_out);
  GB_parse_file(xtool_in,xtool_out,stderr);  
}


void GI_kill_xtool()
{
  fprintf (xtool_out,"(die)\n");
  fflush (xtool_out);
  close(in_sockets[0]);
  close(out_sockets[0]);
  close(in_sockets[1]);
  close(out_sockets[1]);
}





