/*** demo ***/

/*** this style of comment marks things to change ***/

#define TRUE          1
#define FALSE         0
#define DVFILE int

#include <sys/types.h>
#include <cm/cm.h>
#include <cm/cm_stat.h>
#include <cm/cm_file.h>
#include <cm/cmfs.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <cm/paris.h>
#include <cm/cmssl-paris.h>
#include <geodata.h>
#include <geodata_private.h>
#include <types.h>
#include <visbbsub.h>

#include <X11/Intrinsic.h>
#include <Xm/Scale.h>

#define NUM_CHANNELS 15

void demo_scale();
Boolean demo_step_proc();

CM_vp_set_id_t demo_vp;
CM_field_id_t context;
CM_field_id_t demo_step;

CM_vp_set_id_t ship_vp;
CM_field_id_t ship_data;
CM_field_id_t ship_context;
int step;
int out_channels=NUM_CHANNELS;
CM_field_id_t demo_out,bb_out;

int highlight=0;

void main(argc, argv)
     int argc;
     char **argv;
{
  /*** filename should reflect the filename in the 
    (data_desc ship_data ...) in the *_init.gl file ***/
  char *filename="dv:/users/geodata/distribution/ship_demo";
  char param_file_name[80],beam_file_name[80],dv_in_file_name[80];
  char pathname[80];
  int i;
  int steps=128;
  unsigned *fft_amp,*bb_amp;
  CM_field_id_t demo_8bit,demo_send,bb_demo_enum,demo_enum;
  CM_field_id_t demo_bb_8bit;
  CM_field_id_t bb_context;
  CM_geometry_id_t  demo_geo;
  CM_geometry_id_t  send_geo;
  CM_geometry_id_t  ship_geo;
  int ifd;
  unsigned geo[2],send_len;
  GB_id band;
  char name[25];
  int offset,size,bb_offset;
  float f;

  Widget toplevel,scale;
  Arg wargs[10];
  int n;

  CM_init ();
  CMSSL_init ();
  CM_set_safety_mode (1);

  offset=0;
  bb_offset=768;
  size=512;

  geo[0]=8192;
  ship_geo=CM_create_geometry(geo,1);
  ship_vp=CM_allocate_vp_set(ship_geo);
  CM_set_vp_set(ship_vp);
  ship_data=CM_allocate_stack_field(4*32);
  ship_context=CM_allocate_stack_field(1);
  if (ifd=CMFS_open(filename,CMFS_O_RDONLY) < 0){
    CMFS_perror ("open failed");
    exit(1);
  }
  if (CMFS_read_file(ifd,ship_data,(4*32)) != (4*32)){
    CMFS_perror ("read failed");
    exit(1);
  }
  CMFS_close(ifd);


/* set up size x 128 geometry and vp set and allocate 32 bit stack field */
/* allocate geometry_send_address_length bit field in fft_amp vp set */

  geo[0]=size;
  geo[1]=128;
  demo_geo=CM_create_geometry(geo,2);
  demo_vp=CM_allocate_vp_set(demo_geo);
  CM_set_vp_set(demo_vp);
  demo_out=CM_allocate_stack_field(32*out_channels);
  demo_8bit=CM_allocate_stack_field(8*out_channels);
  demo_bb_8bit=CM_allocate_stack_field(8*out_channels);
  bb_out=CM_allocate_stack_field(32);
  context=CM_allocate_stack_field(1);
  demo_step=CM_allocate_stack_field(32);

/* set up filenames */
  for(i=1;i<argc;i++) {
    if(argv[i][0]!='-')break;
    if(argv[i][1]=='h') highlight=atoi(argv[++i]);
  }
  strcpy (param_file_name,"./visbb_param");
  strcpy (beam_file_name,"./param");
  /**** change this to the filename of the raw data ****/
  strcpy (dv_in_file_name,"/users/wanderso/data/time");
  strcpy(pathname,"./demo_init.gl");
  if(i<argc)strcpy(pathname,argv[i]); i++;
  if(i<argc)strcpy(param_file_name,argv[i]); i++;
  if(i<argc)strcpy(beam_file_name,argv[i]); i++;
  if(i<argc)strcpy(dv_in_file_name,argv[i]); i++;

  GI_init(pathname);
  VISBBSUB(&fft_amp,&bb_amp,&send_geo,
	   param_file_name,beam_file_name,dv_in_file_name);
  /*** change "bashful" to one of your machines ****/
  GI_xtool_init(0,"bashful",pathname);
  CM_set_vp_set(CM_field_vp_set(fft_amp));
  send_len=CM_geometry_send_address_length(demo_geo);
  demo_send=CM_allocate_stack_field(send_len);
  demo_enum=CM_allocate_stack_field(send_len);
  bb_demo_enum=CM_allocate_stack_field(send_len);
  bb_context=CM_allocate_stack_field(1);

  for(i=0;i<NUM_CHANNELS;i++) {
    sprintf(name,"acoustic_band%d",i);
    band=GI_get_data_id (name);
    GI_set_cm_data (band, demo_out+i*32, context);
  }
  band=GI_get_data_id ("broad_band_data");
  GI_set_cm_data (band, bb_out, context);
  band=GI_get_data_id ("ship_data");
  GI_set_cm_data (band, ship_data, ship_context);
  for(step = 0; step < steps; step++){ 
    GI_xtool_step();
    fprintf(stderr,"frame # %d\n",step);
    CM_set_vp_set(CM_field_vp_set(fft_amp));
  VISBBSUB(&fft_amp,&bb_amp,0,
	   param_file_name,beam_file_name,dv_in_file_name);
/* make_new_coordinate and deposit_news_coordinate for stepth row */
    CM_my_news_coordinate_1L(demo_enum,1,send_len);
    CM_u_lt_constant_1L(demo_enum,1,send_len);
    CM_logand_context_with_test();
    CM_my_news_coordinate_1L(demo_enum,0,send_len);
    CM_u_le_constant_1L(demo_enum,offset+size,send_len);
    CM_logand_context_with_test();
    CM_u_gt_constant_1L(demo_enum,offset,send_len);
    CM_logand_context_with_test();
    CM_make_news_coordinate_1L(demo_geo,demo_send,0,demo_enum,send_len);
    CM_deposit_news_constant_1L(demo_geo,demo_send,1,128-step,32);
/* send first 512 of fft_amp to stepth row of demo_out */
    CM_send_1L(demo_8bit,demo_send,fft_amp,8*out_channels,CM_no_field);
/* send broadband data to demo_8bit reshuffling to correct alignment */
    CM_set_context();
    CM_set_vp_set_geometry(CM_current_vp_set,send_geo);
    CM_my_news_coordinate_1L(demo_enum,1,send_len);
    CM_u_lt_constant_1L(demo_enum,1,send_len);
    CM_logand_context_with_test();
    CM_my_news_coordinate_1L(demo_enum,0,send_len);
    CM_u_ge_constant_1L(demo_enum,bb_offset,send_len);
    CM_logand_context_with_test();
    CM_u_lt_constant_1L(demo_enum,bb_offset+size,send_len);
    CM_logand_context_with_test();
    CM_store_context(bb_context);
    CM_u_subtract_constant_3_1L(bb_demo_enum,demo_enum,size/2,send_len);
    CM_u_add_constant_2_1L(demo_enum,size/2,send_len);
    CM_u_ge_constant_1L(demo_enum,bb_offset+size,send_len);
    CM_logand_context_with_test();
    CM_u_move_1L(demo_enum,bb_demo_enum);
    CM_load_context(bb_context);
    CM_make_news_coordinate_1L(demo_geo,demo_send,0,demo_enum,send_len);
    CM_deposit_news_constant_1L(demo_geo,demo_send,1,128-step,32);
    CM_send_1L(demo_bb_8bit,demo_send,bb_amp,8,CM_no_field);
    CM_set_vp_set(demo_vp);
    CM_set_context();
    CM_my_news_coordinate_1L(demo_out,1,32);
    CM_u_ge_constant_1L(demo_out,128-step,32);
    CM_store_test(context);
/* convert 8bit to float */
    for(i=0;i<out_channels;i++)
      CM_f_u_float_2_2L(demo_out+32*i,demo_8bit+8*i,8,23,8);
    CM_f_u_float_2_2L(bb_out,demo_bb_8bit,8,23,8);

    CM_set_vp_set(ship_vp);
    CM_set_context();
    f=(float)step;
    CM_f_eq_constant_1L(ship_data+(3*32),f,23,8);
    CM_store_test(ship_context);
    CM_f_eq_constant_1L(ship_data+(3*32),666.0,23,8);
    CM_logior_test(ship_context);
    CM_store_test(ship_context);

    CM_set_vp_set(CM_field_vp_set(fft_amp));
    CM_set_context();
  }   /* end of for step */

  /* slider code */
  toplevel = XtInitialize(argv[0],"Demo",NULL,0,&argc,argv);
  n=0;
  XtSetArg(wargs[n],XmNmaximum,steps); n++;
  XtSetArg(wargs[n],XmNvalue,step); n++;
  XtSetArg(wargs[n],XmNshowValue,TRUE); n++;
  scale = XtCreateManagedWidget("scale",xmScaleWidgetClass,toplevel,
				wargs,n);
  XtAddCallback(scale,XmNvalueChangedCallback,demo_scale,NULL);
  XtRealizeWidget(toplevel);
  XtAddWorkProc(demo_step_proc,0);
  XtMainLoop();
}

void demo_scale(widget, tag, data)
     Widget widget;
     int *tag;
     XmScaleCallbackStruct *data;
{
  float f;
  int step,i,up,low;

  /* read step from slider */
  step=data->value;
  f=(float)step; 
  
  /* set ship_context */
  CM_set_vp_set(ship_vp);
  CM_set_context();
  CM_f_eq_constant_1L(ship_data+(3*32),f,23,8);
  CM_store_test(ship_context);
  CM_f_eq_constant_1L(ship_data+(3*32),666.0,23,8);
  CM_logior_test(ship_context);
  CM_store_test(ship_context);
  
  /* set data context */
  CM_set_vp_set(demo_vp);
  CM_set_context();
  CM_my_news_coordinate_1L(demo_step,1,32);
  for(i=0;i<out_channels;i++) {
    CM_set_context();
    CM_f_ge_constant_1L(demo_out+32*i,256.0,23,8);
    CM_logand_context_with_test();
    CM_f_subtract_constant_2_1L(demo_out+32*i,1000.0,23,8);
    CM_set_context();
    CM_f_ge_constant_1L(demo_out+32*i,256.0,23,8);
    CM_logand_context_with_test();
    CM_f_subtract_constant_2_1L(demo_out+32*i,1000.0,23,8);
    CM_set_context();
    if(highlight==0) {
      CM_u_lt_constant_1L(demo_step,128-step,32);
      CM_logand_context_with_test();
      CM_f_add_constant_2_1L(demo_out+32*i,2000.0,23,8);
    } else {
      up=(128-step)+highlight/2;
      low=(128-step)-highlight/2;
      CM_u_le_constant_1L(demo_step,up,32);
      CM_logand_context_with_test();
      CM_u_ge_constant_1L(demo_step,low,32);
      CM_logand_context_with_test();
      CM_f_add_constant_2_1L(demo_out+32*i,1000.0,23,8);
    }
  }
  CM_set_context();
  CM_f_ge_constant_1L(bb_out,256.0,23,8);
  CM_logand_context_with_test();
  CM_f_subtract_constant_2_1L(bb_out,1000.0,23,8);
  CM_set_context();
  CM_f_ge_constant_1L(bb_out,256.0,23,8);
  CM_logand_context_with_test();
  CM_f_subtract_constant_2_1L(bb_out,1000.0,23,8);
  CM_set_context();
  if(highlight==0) {
    CM_u_lt_constant_1L(demo_step,128-step,32);
    CM_logand_context_with_test();
    CM_f_add_constant_2_1L(bb_out,1000.0,23,8);
  } else {
    up=(128-step)+highlight/2;
    low=(128-step)-highlight/2;
    CM_u_le_constant_1L(demo_step,up,32);
    CM_logand_context_with_test();
    CM_u_ge_constant_1L(demo_step,low,32);
    CM_logand_context_with_test();
    CM_f_add_constant_2_1L(bb_out,1000.0,23,8);
  }
}


Boolean demo_step_proc(i)
     int i;
{
  GI_xtool_step(); 
  return(FALSE);
}
