#include <cm/cm.h>
#include <cm/cm_file.h>
#include <string.h>
#include <cm/cmfs.h>
#include <math.h>
#include <cm/paris.h>

  ABFWEIGHTS(a_in,beam_table,beam_no,n,w)
  unsigned a_in,beam_table,beam_no,n,w;

{
  unsigned a,b,c,s,u,v,atemp;
  int i,j;
  int start[32];

  start[0]=512;start[1]=0;

  a=CM_allocate_stack_field(64*n*n);
  b=CM_allocate_stack_field(64*n*n);
  c=CM_allocate_stack_field(64*n*n);
  s=CM_allocate_stack_field(64*n);
  u=CM_allocate_stack_field(64*n*n);
  v=CM_allocate_stack_field(64*n*n);
  atemp=CM_allocate_stack_field(64);

   HERMUNP (a,a_in,n);

  CSVD (a,n,n,s,u,v);

  HERM (v,n);
  for (i=0;i<n;i++) CM_f_divinto_constant_2_1L (s+i*32,1.,23,8);
  DIAGMULT (v,s,n);
  CMATMULT (b,u,v,n,n,n);
  for (i=0;i<n;i++) {
   for(j=0;j<n;j++) {
    CJMULT2(b+64*i+64*n*j,beam_table+64*j);
    CMULT2(b+64*i+64*n*j,beam_table+64*i);
    }
   }

  for (i=0;i<n;i++) {
    CM_f_move_zero_1L (w+64*i,23,8);
    CM_f_move_zero_1L (w+64*i+32,23,8);
    for (j=0;j<n;j++) {
      CM_f_add_2_1L (w+i*64,b+64*i+64*n*j,23,8);
      CM_f_add_2_1L (w+i*64+32,b+64*i+64*n*j+32,23,8);
     }
    }
 
  CM_f_move_zero_1L (atemp,23,8);
  CM_f_move_zero_1L (atemp+32,23,8);

  for (i=0; i<n; i++) {
     CM_f_add_2_1L ( atemp,w+64*i,23,8);
     CM_f_add_2_1L ( atemp+32,w+64*i+32,23,8);
   }

  for (i=0; i<n; i++) {
     CM_f_divide_2_1L ( w+64*i,atemp,23,8);
     CM_f_divide_2_1L ( w+64*i+32,atemp,23,8);
   }

  CM_deallocate_stack_through (a);

}



