/*

            1. Read data from data vault
            4. FFT the data
            7. Bandpass filter the spectrums
           10. Inverse FFT
           14. Store data to DataVault

*/

#include <sys/types.h>
#include <cm/cm.h>
#include <cm/cm_stat.h>
#include <cm/cm_file.h>
#include <cm/cmfs.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <cm/paris.h>
#include <cmssl/cmssl-paris.h>
#define TRUE          1
#define FALSE         0
#define DVFILE int


void main(argc, argv)
     int argc;
     char **argv;
{
  char dv_in_file_name[128], dv_out_file_name[128], param_file_name[128];
  DVFILE dv_infile, dv_outfile;
  int number;
  int aver,save_aver;
  int p,pts, steps, ptr, step;
  int ARRAY,array,copy=4;
  int sample_size=32;
  int decomp=FALSE,take_hann,overlap =1, ser_data=FALSE;
  int update,size,zero_fill=FALSE;
  int CHANNELS;
  int channels_per_array_1,channels_per_array_2,channels_per_array;
  int n_beams,sweeps_in,sweeps_out,cut;
  int scot_flag=0,int_data=FALSE;
  int sweep_count=0;
  int debu, dbu, bits;
  float te[128];
  unsigned start[32],stop[32];
  float xpts;
  float cnst;
  int nproc;
  int ncut;

  struct cm_stat instat;

  unsigned  pure_data,
  old_data,
  gfilt,
  cmte,                    /* decompansion table */
  fft_temp,
  fft_aver,
  out_amp;
  
  CM_geometry_id_t new_geometry,send_geometry,cut_geometry;
  unsigned dimension_array[1], new_vp_set;
  CMSSL_fft_setup_t id;
  CMSSL_fft_setup_t idinv;
  CMSSL_op_t ops[2]; 
  CMSSL_bit_order_t sbo[2],dbo[2];
  CMSSL_scale_t sca[2];
  CMSSL_op_t opscor[2]; 
  CMSSL_bit_order_t sbocor[2],dbocor[2];
  CMSSL_scale_t scacor[2];
  struct CM_axis_descriptor axe_desc[32];
  CM_axis_descriptor_t axe_desc_t[32];
  int i;
  int i1,i2,i3,a1,a2,a3;
  int num_filt,nlo,nhi;
  FILE *fopen(), *fp;

  start[0]=0;start[1]=0;stop[0]=16;stop[1]=0;

  CM_init ();
  CMSSL_init ();
  CM_set_safety_mode (1); 

/* Process filename & arguments: */
  dv_in_file_name[0] = '\0';
  dv_out_file_name[0] = '\0';
  param_file_name[0] = '\0';
  if (argc > 1) strcpy(dv_in_file_name, argv[1]);
  if (argc > 2) strcpy(dv_out_file_name, argv[2]);
  if (argc > 3) strcpy(param_file_name, argv[3]);

  fp=fopen (param_file_name,"r");
  if (fp == NULL) { fprintf (stderr,"Couldn't open file \n"); exit(0);}
    fscanf (fp,"%d %*S \n",&p);
    pts=1<<p;
    printf ("%d \n",pts);
      update=pts/2;
      size=pts;
    fscanf (fp,"%d %*S \n",&ARRAY);
    printf ("%d \n",ARRAY);
    fscanf (fp,"%d %*S \n",&channels_per_array_1);
    printf ("%d \n",channels_per_array_1);
    fscanf (fp,"%d %*S \n",&channels_per_array_2);
    printf ("%d \n",channels_per_array_2);
      channels_per_array=channels_per_array_1+channels_per_array_2;
    fscanf (fp,"%d %*S \n",&n_beams);
    printf ("%d \n",n_beams);
    fscanf (fp,"%d %*S \n",&sweeps_in);
    printf ("%d \n",sweeps_in);
    fscanf (fp,"%d %*S \n",&sweeps_out);
    printf ("%d \n",sweeps_out);
    fscanf (fp,"%d %*S \n",&cut);
    printf ("%d \n",cut);
      ncut=1<<cut;
    fscanf (fp,"%d %*S \n",&steps);
    printf ("%d \n",steps);
    fscanf (fp,"%d %*S \n",&aver);
    printf ("%d \n",aver);
        save_aver = aver;
    fscanf (fp,"%d %*S \n",&int_data);
    printf ("%d \n",int_data);
    fscanf (fp,"%d %*S \n",&decomp);
    printf ("%d \n",decomp);
    fscanf (fp,"%d %*S \n",&sample_size);
    printf ("%d \n",sample_size);
    fscanf (fp,"%d %*S \n",&ser_data);
    printf ("%d \n",ser_data);
    fscanf (fp,"%d %*S \n",&take_hann);
    printf ("%d \n",take_hann);
    fscanf (fp,"%d %*S \n",&overlap);
    printf ("%d \n",overlap);
      update=update/overlap;
    fscanf (fp,"%d %d %d \n",&num_filt, &nlo, &nhi);
    printf ("%d %d %d \n",num_filt,nlo,nhi);

/* set up FFT configuration */

  ops[0]=CMSSL_f_xform;
  sbo[0]=CMSSL_normal;
  dbo[0]=CMSSL_bit_reversed;
  sca[0]=CMSSL_noscale;
  ops[1]=CMSSL_nop;
  sbo[1]=CMSSL_normal;
  dbo[1]=CMSSL_normal;
  sca[1]=CMSSL_noscale;
  opscor[0]=CMSSL_i_xform;
  sbocor[0]=CMSSL_bit_reversed;
  dbocor[0]=CMSSL_normal;
  scacor[0]=CMSSL_scale_n;
  opscor[1]=CMSSL_nop;
  sbocor[1]=CMSSL_normal;
  dbocor[1]=CMSSL_normal;
  scacor[1]=CMSSL_noscale;
   for (i = 0; i < 2; i++) {
        axe_desc[i].weight = 1-i;
        axe_desc[i].ordering = CM_send_order;
        axe_desc[i].off_chip_bits = 0;
        axe_desc[i].off_chip_pos = 0; 
        axe_desc[i].on_chip_bits = 0;
        axe_desc[i].on_chip_pos = 0;
        axe_desc_t[i] = &(axe_desc[i]);
      }

  nproc=CM_geometry_total_processors(CM_vp_set_geometry(CM_current_vp_set));
  array=nproc/(pts/2);
   
  CHANNELS=(ARRAY/array)*channels_per_array;
   axe_desc[0].length = array*pts/2;
   send_geometry = CM_create_detailed_geometry((unsigned *)(&axe_desc_t[0]),1);
   axe_desc[1].length = array;
   axe_desc[0].length = pts/2;
   new_geometry = CM_create_detailed_geometry((unsigned *)(&axe_desc_t[0]),2);
   axe_desc[1].length = ncut*array;
   axe_desc[0].length = pts/2/ncut;
   cut_geometry = CM_create_detailed_geometry((unsigned *)(&axe_desc_t[0]),2);

  new_vp_set = CM_allocate_vp_set(new_geometry);
  CM_set_vp_set(new_vp_set);
  CM_set_context();
 
/* Allocate CM memory */
  num_filt=1;
  fft_temp=CM_allocate_stack_field(64*CHANNELS);    
  id= CMSSL_c_c_fft_setup_1L (fft_temp,23,8);
  CM_set_vp_set_geometry(CM_current_vp_set, cut_geometry);
  fft_aver=CM_allocate_stack_field(64*CHANNELS);
  idinv= CMSSL_c_c_fft_setup_1L (fft_aver,23,8);
  CM_set_vp_set_geometry(CM_current_vp_set, new_geometry);
    
  pure_data=CM_allocate_stack_field(sample_size*CHANNELS*2);
  old_data=CM_allocate_stack_field(sample_size*CHANNELS*2*(sweeps_in+1));
  cmte=CM_allocate_stack_field(4*32);
  gfilt=CM_allocate_stack_field(32);
  out_amp=CM_allocate_stack_field(32*CHANNELS*sweeps_out);

/* Open DataVault files for input, filter, and output */
  if ((dv_infile = CMFS_open(dv_in_file_name, CMFS_O_RDONLY, 0644,
			     CM_physical_processors_limit,
			     CM_user_number_of_processors_limit)) == -1){
    printf("error on dv file open: %s\n", dv_in_file_name);
    CMFS_perror("");
    exit(1);
  }
  if (steps == 0) {
     steps=CMFS_fstat(dv_infile,&instat);
     steps=(instat.cmst_size/(sample_size/8)/pts/ARRAY/
              CHANNELS*(pts/(2*update)))-1;
     printf ("  step = %i \n",steps);
   }
  printf (" file opened \n");

  if ((dv_outfile = CMFS_open(dv_out_file_name, CMFS_O_RDWR | CM_CREAT, 0644,
			      CM_physical_processors_limit,
			      CM_user_number_of_processors_limit)) == -1){
    printf("error on dv file open: %s\n", dv_out_file_name);
    
    exit(1);
  }
  printf (" file opened \n");
  
  {
    int channel, bits, odd, beam, table_index, i;
    int mv_offset;
    int offset =0;
    

/* Initialize CM memory */
    for (debu = 0;  debu < 128; debu++) te[debu] = 0;
    COMPUTE_DECOMP_TABLE(te);
    if (decomp) LOAD_DECOMP_TABLE(te, cmte);
    GFILTBP (gfilt,nlo,nhi,TRUE);
/*Initial load of data into CM memory */
    INITDATA (old_data,CHANNELS*sample_size*2*(sweeps_in+1),
              sample_size/4,ser_data,dv_infile);
    for(step = 0; step < steps; step++){
      
/* Input time series data */
    LOADDATA (pure_data,old_data,CHANNELS*sample_size*2,dv_infile,
               offset,size/2,sweeps_in,FALSE,sample_size/4,ser_data);
    if ( offset >= sweeps_in*pts/2) offset += -sweeps_in*pts/2;
    offset += update;
/* Move data before FFTing */

    if (decomp) {
      for (channel =0; channel < 2*CHANNELS; channel++){
        DECOMPAND(fft_temp+32*channel, pure_data+sample_size*channel, cmte);
       }
    }
    else if (int_data){
      for (channel = 0; channel <2*CHANNELS; channel++){
         CM_f_s_float_2_2L (fft_temp+32*channel,
                     pure_data+sample_size*channel, sample_size,23,8);
       }
     }

      else {
      for (channel = 0; channel < 2*CHANNELS; channel++){
        CM_u_move_1L (fft_temp+32*channel, pure_data+sample_size*channel, 
                         sample_size);
       }
      }

/* FFT the data */
    for (channel = 0; channel < CHANNELS; channel ++){
        CMSSL_c_c_fft_detailed_a_1L (fft_temp+64*channel,id,ops,sbo,dbo,
               sca,23,8);
     }

    UNS2REAL2D(fft_temp,  p, CHANNELS,1,TRUE);

/* Band pass spectrums */
    for ( channel=0; channel < CHANNELS; channel++ ) {
     CM_f_multiply_2_1L (fft_temp+32*channel,gfilt,23,8);
     CM_f_multiply_2_1L (fft_temp+32*channel,gfilt,23,8);
       }

    CM_set_vp_set_geometry(CM_current_vp_set, cut_geometry);
    CM_u_move_1L(fft_aver,fft_temp,64*CHANNELS);
    if (cut !=0 ) COPYFREQB (fft_aver,fft_temp,64*CHANNELS,cut);


    SCR2REAL2D(fft_aver,  p-cut, CHANNELS,1,cut_geometry, TRUE);

    for (channel = 0; channel < CHANNELS; channel ++){
        CMSSL_c_c_fft_detailed_a_1L (fft_aver+64*channel,idinv,opscor,sbocor
                    ,dbocor,scacor,23,8);
     }

/* save correlations */
 
   for (i=0;i<2*CHANNELS;i++) { 
     CM_s_f_floor_2_2L(fft_temp+16*i,fft_aver+32*i,16,23,8);
    }
   for (i=0;i<CHANNELS;i++) { 
     CMFS_transpose_always(fft_temp+32*i,32,CMFS_IO_WRITE_TO_SERIAL_DATA,NULL);
    }
    CM_u_move_1L(out_amp+sweep_count*32*CHANNELS,fft_temp,32*CHANNELS);
    sweep_count += 1;
   if (sweep_count == sweeps_out) {
     SAVE_AMPLITUDE(out_amp, 0, dv_outfile,4*sweeps_out*CHANNELS);
     sweep_count=0;
   }

    CM_set_vp_set_geometry(CM_current_vp_set, new_geometry);
    }
    
    fflush(stdout);	      
  }  

     SAVE_AMPLITUDE(out_amp, 0, dv_outfile,4*sweep_count*CHANNELS);
  CMFS_close(dv_infile);
  CMFS_close(dv_outfile);
}
