/*

   CJMULT - Multiplies the complex numbers stored in a slice in CM memory 
            by the complex conjugate of a second slice in PE memory. Call-
            ing sequence is

          CJMULT ( out, in1,in2)

  where

          out    - Pointer to the slice in CM memory  where 
                   the result is to be stored
          in1    - Pointer to first input vector slice
          in2    - Pointer to second input vector slice

*/

#include <cm/paris.h>


  void CJMULT(out, in1, in2)
  unsigned in1,in2,out;
{

    CM_f_multiply_3_1L ( out, in1,in2,23,8);
    CM_f_mult_add_1L (out,in1+32,in2+32,out,23,8); 
    CM_f_multiply_3_1L (out+32,in1+32,in2,23,8);
    CM_f_mult_subf_1L ( out+32,in1,in2+32,out+32,23,8);

}
