/*

   CJMULT2 - Multiplies the complex numbers stored in a slice in CM memory 
            by the complex numbers in a second slice in PE memory. Call-
            ing sequence is

          CJMULT2 ( out,in2)

  where

          out    - Pointer to the slice in CM memory  where 
                   the result is to be stored and pointer to 
                   first input vector slice
          in2    - Pointer to second input vector slice

*/

#include <cm/paris.h>


  void CJMULT2(out, in2)
  unsigned in2,out;
{
    unsigned in1;

    in1=CM_allocate_stack_field(64);
    CM_u_move_1L (in1,out,64);
    CM_f_multiply_3_1L ( out, in1,in2,23,8);
    CM_f_mult_add_1L (out,in1+32,in2+32,out,23,8); 
    CM_f_multiply_3_1L (out+32,in1+32,in2,23,8);
    CM_f_mult_subf_1L ( out+32,in1,in2+32,out+32,23,8);
    CM_deallocate_stack_through(in1);

}
