/******************************************************************************
*                                                                             *
*  CLIP - clips the values in a slice of CM memory and then scales the        *
*         data up                                                             *
*                                                                             *
*          value - Pointer to slice of CM memory to contain both original     *
*                  and clipped/scaled values                                  *
*          cp    - Value at which to clip data                                *
*          shft  - Value by which to scale data                               *
*                                                                             *
******************************************************************************/

#include <cm/paris.h>

  void CLIP(value, cp, shft)
  CM_memaddr_t value;
  float cp, shft;
{
  CM_memaddr_t ctx = CM_allocate_stack_field (1);
  
  CM_store_context (ctx);
  CM_f_ge_constant_1L(value, cp, 23, 8);
  CM_logand_context_with_test();
  CM_f_move_constant_1L(value, cp, 23, 8);
  CM_load_context(ctx);
  CM_f_multiply_constant_2_1L(value, shft, 23, 8); 
  CM_deallocate_stack_through (ctx);
} 
