/******************************************************************************
*                                                                             *
*  COMPUTE_DECOMP_TABLE - Creates the decompansion table for 8-bit to 12 bit  *
*                         decompansion and stores in a front-end array. The   *
*                         decompansion is based on the u-law 255 formula      *
*                         deleoped by AT&T Bell Labs.                         *
*                                                                             *
*     te - front end aray to contain decompansion values ( positive only)     *
*                                                                             *
******************************************************************************/

#include <stdio.h>
#include <cm/paris.h>
#include <math.h>

  double two(k)
  int k;
{
  double two = 2;
  return(pow(two, (double) k));
}


  void COMPUTE_DECOMP_TABLE(te)
  float te[128];
{
  int i, j, k, iflag, seg, mant, icomp, isum, tc[2048];

/*  Calculate compansion taable for 12-bit data stored as high bits of
    16 bit word (postive values) */
  for(i = 0; i < 2048; i++) {
    iflag = 0;
    for(k = 4; ((k <= 11) && !iflag); k++){
      if (((two(k) - 16) <= i) && (i < ((two((k + 1)) - 16)))){
	seg = k - 4;
	mant = ((i - (two(k) - 16)) / two(seg));
	icomp = 16 * seg + mant;
	iflag = 1;
      }
    }
  if (!iflag){
      printf("muteable error, integer %d is not compressed.\n", i);
      exit(0);
    }
    tc[i] = icomp;
  } 

  isum = 0;
  j = 0;
  k = 1;

/* Set decompaansion value as average of all values mapped to it. */

  for(i = 0; i < 2047; i++){
    if (tc[i] == tc[i + 1]){
      isum += (i + 1);
      k++;
     }
    else{
      te[j] = isum / k;
      isum = i + 1;
      j++;
      k = 1;
     }
  }
  te[j] = isum / k;
} 

