/*

   CSPECTPCK   - Calculates the cross spectrum of a complex spectrum stored
              in CM memory. Calling sequence is

          CSPECTPCK ( a, f, n)

  where

          a      - Pointer to the cross spectrum matrix in CM memory 
          f      - Pointer to complex spectrum vector in CM memory
          n      - Number of data channels

*/

#include <cm/paris.h>


  void CSPECTPCK(a, f, n)
  unsigned a,f;
  int n;

{

  unsigned temp,ftemp;
  int i,j,ind;
  float alpha=1.,beta=1.;
  temp=CM_allocate_stack_field(64);
  ftemp=CM_allocate_stack_field(64);
  
  ind =0;
  for (i=0;i<n;i++) {
   CM_f_multiply_constant_3_1L (ftemp,f+64*i,alpha,23,8);
   CM_f_multiply_constant_3_1L (ftemp+32,f+64*i+32,alpha,23,8);
    for (j=0;j<i+1;j++) {
     CONJMULT(temp,f+64*j,ftemp,1);
     CM_f_mult_const_add_1L (a+64*ind,a+64*ind,beta,temp,23,8);
     CM_f_mult_const_add_1L (a+64*ind+32,a+64*ind+32,beta,temp+32,
              23,8);
     ind ++;
       }
     }

  CM_deallocate_stack_through(temp);

}
