/******************************************************************************
*                                                                             *
*  DECOMPAND - Converts data stored in Cm memory from 8-bit companded format  *
*              to a 32 bit IEEE floating point.  Method is by table lookup.   *
*                                                                             *
*        dest - Slice of CM memory to contain decompanded data                *
*        pure - Slice of CM memory containing companded data                  *
*        cmte - Shared array in CM memory containing table                    *
*               of decompanded values for positve data                        *
*                                                                             *
******************************************************************************/

#include <stdio.h>
#include <cm/paris.h>
#include <math.h>

  int DECOMPAND(dest, pure, cmte)
  CM_memaddr_t dest, pure, cmte;

{
  CM_memaddr_t lookupindex = CM_allocate_stack_field(8);

  CM_set_context(); 
  CM_s_move_1L(lookupindex, pure, 8);
  CM_s_lt_zero_1L (pure,8);
  CM_logand_context_with_test();
  CM_s_negate_1_1L(lookupindex, 8);
  CM_set_context(); 
  CM_aref32_shared_2L(dest, cmte, lookupindex, 32, 8, 128);
  CM_s_lt_zero_1L (pure,8);
  CM_logand_context_with_test();
  CM_f_negate_1_1L(dest, 23, 8);
  CM_set_context();
  CM_deallocate_stack_through(lookupindex);
} 
