/*

   DIAGMULT - Multiplies the real diagonal "vector" stored in a slice in CM 
              memory by the complex matrix in a second slice in PE memory. 
              Operation is inplace.  Calling sequence is

          DIAGMULT ( out, in1,m)

  where

          out    - Pointer to the slice in CM memory containing the matrix
          in1    - Pointer to "diagonal" vector
          m      - Number of rows/columns of input matrix

*/

#include <cm/paris.h>

  void DIAGMULT(out, in1, m)
  unsigned in1,out;
  int m;
{

  int i,j;

  for (i=0;i<m;i++) {
    for (j=0;j<m;j++) {
      CM_f_multiply_2_1L (out+64*i+64*m*j,in1+32*i,23,8);
      CM_f_multiply_2_1L (out+64*i+64*m*j+32,in1+32*i,23,8);
     }
  }

}
