/*

   HERM - Finds the complex congugate transpose of a square matrix. 
          The operation is performed in place.  Calling sequence is

          HERM ( out, m)

  where

          out    - Pointer to the slice in CM memory ccontaining the array
          m      - Number of rows and columns in the matrix

*/

#include <cm/paris.h>


  void HERM(out, m)
  unsigned out;
  int m;
{

  unsigned temp;
  int i,j;

  temp=CM_allocate_stack_field(64);
  
  for (i=0;i<m;i++) {
    CM_f_negate_1_1L (out+64*i+64*m*i+32,23,8);
    for (j=i+1;j<m;j++) {
     CM_c_move_1L (temp,out+64*i+64*m*j,23,8);
     CM_c_move_1L (out+64*i+64*m*j,out+64*j+64*m*i,23,8);
     CM_c_move_1L (out+64*j+64*m*i,temp,23,8);
     CM_f_negate_1_1L (out+64*i+64*m*j+32,23,8);
     CM_f_negate_1_1L (out+64*j+64*m*i+32,23,8);
     }
  }

  CM_deallocate_stack_through(temp);

}
