/******************************************************************************
*                                                                             *
*  INITDATA - Fills data buffer from a file on the DataVault                  *
*                                                                             *
*    new_data  - Pointer to slice in CM memory for input buffer               *
*    move      - Size (number of bits per processor) of each data buffer      *
*    bytes     - Number of bytes in a data_sample                             *
*    pflag     - Flag to indicate whther or not data is serial and must       *
*                be converted to parallel format                              *
*    dv_infile - Pointer to DataVault file                                    *
*                                                                             *
******************************************************************************/

#include <cm/paris.h>
#include <cm/cm_file.h>
#include <cm/cmfs.h>
#include <cm/cm_stat.h>

  void INITDATA (old_data, move,bytes,pflag,dv_infile)
  unsigned old_data;
  int dv_infile;
  int move,bytes,pflag;

{
  int bits,inner;

  bits = CMFS_read_file(dv_infile, old_data, move);
  if (bits == -1){
   CMFS_perror("Had trouble reading data."); exit(1);
  }
  if ( pflag) {
   for (inner=0; inner< move; inner+= 8*bytes) {
        CMFS_transpose_always(old_data+inner,8*bytes,
             CMFS_IO_READ_FROM_SERIAL_DATA,CMFS_read_from_column_major);
      }
  }
}
 
