/*
 *
 * Calling procedure:
 *      unsigned real_part,n;
 *      real_part = CM_allocate_stack_field(32);
 *      MAG(real_part, p, steps);
 */

#include <cm/paris.h>
#include <math.h>

void MAG (real_part, p, steps,range)
unsigned real_part, p, steps;
float range;

{
    unsigned i,j,k,pcal ;
    float fmax,fmin,fnew ;
    unsigned temp;
    unsigned n=1<<p;
    unsigned name, coordinate_save;

 pcal = CM_geometry_send_address_length(CM_vp_set_geometry(CM_current_vp_set));
 coordinate_save = CM_allocate_stack_field(1);
 name = CM_allocate_stack_field(pcal);
 CM_my_send_address_1L(name);
 CM_store_context(coordinate_save);
 CM_set_context();
 for (i=0; i<steps; i++ ) {
   CM_f_ln_1_1L (real_part+32*i,23,8);
   CM_f_multiply_constant_2_1L(real_part+32*i,6.0206,23,8);
 }
 CM_u_ne_zero_1L (name+1,p-2) ;
 CM_logand_context_with_test();
  
   fmax=CM_global_f_max_1L (real_part,23,8);
 for (i=1; i<steps; i++ ) {
   fnew=CM_global_f_max_1L (real_part+32*i,23,8);
   if (fnew > fmax) fmax=fnew;
 }

   CM_set_context(); 
  for (i=0; i<steps; i++) {
   CM_f_le_constant_1L (real_part+32*i,fmax-range,23,8);
   CM_logand_context_with_test();
   CM_f_move_constant_1L (real_part+32*i,fmax-range,23,8);
   CM_set_context();
  }
  for (i=0; i<steps; i++) {
   CM_f_add_constant_2_1L (real_part+32*i,range-fmax,23,8);
  }
 
  fmax=5./range;
  for (i=0; i<steps; i++) {
   CM_f_multiply_constant_2_1L (real_part+32*i,fmax,23,8);
   CM_set_context();
  }

 CM_load_context (coordinate_save) ;
 CM_deallocate_stack_through(coordinate_save);
}

