/******************************************************************************
*                                                                             *
*  NEWSTOSEND - Reoder data in processors from NEWS order to SEND order.      *
*                                                                             *
*     array  -  Slice containing data                                         *
*     num    -  number of data bits in each PE                                *
*                                                                             *
******************************************************************************/

#include <cm/paris.h>
#include <math.h>

  void NEWSTOSEND (array,num)
  unsigned array, num;
{
  unsigned p, pcal;
  CM_geometry_id_t current_geometry;
  unsigned temp;
  unsigned sa,x,y;

  current_geometry=CM_vp_set_geometry(CM_current_vp_set);
  pcal =CM_geometry_send_address_length(current_geometry);
  p = CM_geometry_coordinate_length (current_geometry,0);
  sa = CM_allocate_stack_field(pcal);
  CM_u_move_zero_1L(sa, pcal);
  CM_my_send_address_1L(sa);

  temp=CM_allocate_stack_field(num);
  x=CM_allocate_stack_field(p);
  y=CM_allocate_stack_field(pcal-p);
  CM_extract_news_coordinate_1L(current_geometry,x,0,sa,p);
  if (pcal != p) CM_extract_news_coordinate_1L(current_geometry,y,1,sa,pcal-p);
  CM_u_move_1L(sa,x,p); 
  if ( pcal != p)  CM_u_move_1L(sa+p,y,pcal-p); 
  CM_u_move_1L (temp,array,num);
  CM_send_1L ( array,sa,temp,num,CM_no_field);

  CM_deallocate_stack_through(temp);
}
