/*
 *
 * Calling procedure:
 *      unsigned real_part,n;
 *      real_part = CM_allocate_stack_field(32);
 *      NSE(real_part, p, G, W);
 * where
 *      n               is the number of data points
 */

#include <cm/paris.h>
#include <math.h>
#include <stdio.h>

void NSE (real_part, p, slices, G, W)
unsigned real_part;
int G, W, p, slices;
  {
    int npass, i, j, k, N;
    float K;
    unsigned narrower, noise, noise_lag, temp, save_context, shifted;
    int count, x[2], y[2];

    npass = 3;
    K = 2.;
    N = 1 << p;

    noise = CM_allocate_stack_field(slices * 32);
    noise_lag = CM_allocate_stack_field(slices * 32);
    temp = CM_allocate_stack_field(slices * 32);
    shifted = CM_allocate_stack_field(slices * 32);
    narrower = CM_allocate_stack_field(1);
    save_context = CM_allocate_stack_field(1);

    /* Figure out how many shift/adds to do. */
    count = 0;
    for (i = 1; i < (W - G) / 2; i *= 2)
      count++;

    x[0] = 80, y[0] = 119, x[1] = 0, y[1] = 0;
    
    CM_store_context(save_context);
    CM_set_context();
    CM_my_news_coordinate_1L(temp, 0, 32);
    CM_u_ge_constant_1L(temp, (W - 1) / 2, 32);
    CM_logand_context_with_test();
    CM_u_le_constant_1L(temp, N - (W + 1) / 2, 32);
    CM_logand_context_with_test();
    CM_store_context(narrower);
    CM_set_context();

    CM_u_move_1L(temp, real_part, 32 * slices);
    for (i = 1; i <= npass; i++)
      {
	CM_u_move_1L(noise, temp, 32 * slices);
	for (j = 0; j < count; j++)
	  {
	    CM_get_from_power_two_always_1L(shifted, noise, 0, j, CM_upward,
					    32 * slices);
	    for (k = 0; k < slices; k++)
	      CM_f_add_2_1L (noise + k * 32, shifted + k * 32, 23, 8);
	  }
	SHIFT(noise_lag, noise, 0, - (W-1) / 2, 32 * slices);
	SHIFT(noise, noise, 0, (G+1) / 2, 32 * slices);
	for (k = 0; k < slices; k++)
	  CM_f_add_2_1L (noise + k * 32, noise_lag + k * 32, 23, 8);
	for (k = 0; k < slices; k++)
	  CM_f_divide_constant_2_1L (noise + k * 32, (float) (W - G), 23, 8);
	if (i < npass)
	  for (k = 0; k < slices; k++)
	    {
	      CM_f_multiply_constant_2_1L(noise + k * 32, K, 23, 8);
	      CM_load_context(narrower);
	      CM_f_lt_1L(noise + k * 32, temp + k * 32, 23, 8);
	      CM_logand_context_with_test();
	      CM_f_divide_constant_3_1L(temp + k * 32, noise_lag + k * 32,
					(float) (W - G) / 2, 23, 8);
	      CM_set_context();
	    }
      }
    for (k = 0; k < slices; k++)
      CM_f_divide_2_1L(real_part + k * 32, noise + k * 32, 23, 8);
    CM_deallocate_stack_through(noise);
  }



