#include <stdio.h>
#include <string.h>
#include <cm/paris.h>
#include <cm/cm_file.h>
#include <cm/cmfs.h>
#include <cm/cm_stat.h>

void usage()
{
  fprintf(stderr,"useage: reforser infile outfile \n");
  fprintf(stderr, "\t-c n ==>number of channels defaults to 8.\n");
  fprintf(stderr, "\t-l m ==>number of lines, defaults to 256.\n");
  fprintf(stderr, "\t-b b ==>number of bytes in word.\n");
  exit (1);
}

void main(argc, argv)
int argc;
char **argv;
{

  char dv_in_file[128],dv_out_file[128];
  int in_data, out_data;
  int bits,bits_out,ptr;
  int swap=0;
  int i,p,bytes=4;
  int lines=256,channels=8,pts,copy=1;
  int steps,buffer,inner;
  int dvfile_in;
  int dvfile_out;
  int saved_channels ;
  CM_geometry_id_t new_geometry;
  CM_geometry_id_t default_geometry;
  unsigned dimension_array[1];
  struct CM_axis_descriptor axe_desc[32];
  CM_axis_descriptor_t axe_desc_t[32];
  struct cm_stat *buf;
  struct cm_stat temp[2];
  long transpose_size=16384/4;

  if (argc < 3)
    {printf("useage: reformat in_filename out_filename.\n"); exit(0);}
  strcpy(dv_in_file, argv[1]);
  strcpy(dv_out_file, argv[2]);
  for (ptr=3; ptr<argc; ptr++) {
    char *arg = argv[ptr];
    if (arg[0] == '-') {
      switch (arg[1]) {
      case 'b':                          
        if (++ptr >= argc) usage ();
        bytes = atoi(argv[ptr]);
        continue;
      case 'd':                          
        if (++ptr >= argc) usage ();
        copy = atoi(argv[ptr]);
        continue;
      case 's':
        swap = 1;
        continue;
      default: usage ();
      }
    }
    else usage();
  }

  CM_init();
  CM_set_safety_mode (0);


   for (i = 0; i < 2; i++) {
        axe_desc[i].weight = 0;
        axe_desc[i].ordering = CM_send_order;
        axe_desc[i].off_chip_bits = 0;
        axe_desc[i].off_chip_pos = 0;
        axe_desc[i].on_chip_bits = 0;
        axe_desc[i].on_chip_pos = 0;
        axe_desc_t[i] = &(axe_desc[i]);
      }
 default_geometry=CM_vp_set_geometry(CM_current_vp_set);
 p=CM_geometry_send_address_length(default_geometry);
 pts=1<<p;
 axe_desc[0].length = pts;
 new_geometry = CM_create_detailed_geometry((unsigned *)(&axe_desc_t[0]), 1);
  CM_set_vp_set_geometry (CM_current_vp_set,new_geometry);

  in_data=CM_allocate_stack_field(transpose_size);
  out_data=CM_allocate_stack_field(transpose_size*copy);

  printf("opening in file...\n");
  if ((dvfile_in = CMFS_open(dv_in_file, CMFS_O_RDONLY, 0644))  == -1){
    printf("error on dv file open: %s\n", dv_in_file);
    exit(1);  }
  printf (" I am here");
  printf("opening out file...\n");
  if ((dvfile_out = CMFS_open(dv_out_file, CMFS_O_WRONLY | CMFS_O_CREAT, 0644))  == -1){
    printf("error on out file open: %s\n", dv_out_file);
    exit(1);  }
 bits=transpose_size;
 bits_out=transpose_size*copy;
 while (bits == transpose_size) {
    bits = CMFS_read_file(dvfile_in, in_data, transpose_size);
    if (bits == -1){CMFS_perror("Couldn't read some data"); exit(-1);}
    else printf("read %d bits of data from channel saveset %d per vp.\n",
	      bits, steps);
     for (inner=0; inner< bits; inner+= 8*bytes) {
       if (swap !=0) {
         for (i=0; i< bytes/2; i++) {
          CM_swap_2_1L ( in_data+inner+8*(bytes-1-i), in_data+inner+8*i,8);
	 }
       }
         CMFS_transpose_always(in_data+inner,8*bytes,
             CMFS_IO_WRITE_TO_SERIAL_DATA,NULL);
      }

     for (inner=0; inner< bits; inner+= 8*bytes) {
      for (i=0; i<copy;i++){
        CM_u_move_1L (out_data+inner*copy+8*bytes*i,
                         in_data+inner,8*bytes);
      }
    }
    bits_out = CMFS_write_file(dvfile_out, out_data,bits_out);
    if (bits_out == -1)
      {CMFS_perror("Couldn't write some data"); exit(-1);}
    }

}
