/******************************************************************************
*                                                                             *
*  READCMFILE - Reads data from a parallel DataVault file into the            *
*                  memory of the Connection Machine                           *
*                                                                             *
*      file_name - File name of DataVault file                                *
*      address   - Slice of Cm memory to contain data                         *
*      size      - Number of bits to read per processing element              *
*                                                                             *
******************************************************************************/

#include <cm/paris.h>
#include <cm/cm_file.h>
#include <cm/cmfs.h>


  void READCMFILE(file_name,address,size)
  char file_name[];
  unsigned address;
  int size;

{
  int dv_file,bits ;

  if ((dv_file = CMFS_open(file_name, CMFS_O_RDONLY, 0644,
                             CM_physical_processors_limit,
                             CM_user_number_of_processors_limit)) == -1){
    printf("error on dv file open: %s\n", file_name);
    exit(1);
   }
  printf (" file opened \n");
  bits = CMFS_read_file_always(dv_file, address, size);
  if (bits == -1){CMFS_perror("Had trouble reading file"); exit(1);}
  CMFS_close(dv_file);

}
