#include <cm/cm.h>
#include <cm/cm_file.h>
#include <string.h>
#include <cm/cmfs.h>
#include <math.h>
#include <cm/paris.h>

void  main(argc,argv)
   int argc;
   char **argv;
{
  unsigned a,a_in,b,c,d,e,f,s,u,v,out,atemp,w;
  int m=5,n=5;
  int i,j,bits;
  char dv_cross_file_name[128],dv_cal_file_name[128];
  int dv_crossfile;
  int pcal,nproc;
  unsigned name,name_send;
  unsigned new_vp_set;
  CM_geometry_id_t new_geometry;
  struct CM_axis_descriptor axe_desc[32];
  CM_axis_descriptor_t axe_desc_t[32];
  float fmax;
  char beam_file_name[128];
  unsigned beam_table;
  float cnst;

  CM_init();
  CM_set_safety_mode (1);

  strcpy(dv_cross_file_name, "cross.out");
  if ((dv_crossfile = CMFS_open(dv_cross_file_name, CMFS_O_RDONLY, 0644,
                             CM_physical_processors_limit,
                             CM_user_number_of_processors_limit)) == -1){
    printf("error on dv file open: %s\n", dv_cross_file_name);
    exit(1);
  }

  new_geometry=CMFS_file_geometry(dv_crossfile);
  new_vp_set = CM_allocate_vp_set(new_geometry);
  CM_set_vp_set(new_vp_set);
  CM_set_context();
  beam_table=CM_allocate_stack_field(64*n*n);
  dv_cal_file_name[0] = '\0';
  strcpy(beam_file_name, argv[1]);
  BEAMTABLEAPT(beam_file_name,beam_table,0,n,1,n,&cnst,dv_cal_file_name);

  a_in=CM_allocate_stack_field(64*m*(m+1)/2);
  w=CM_allocate_stack_field(64*n);

  bits = CMFS_read_file(dv_crossfile, a_in, 64*n*(n+1)/2);
  if (bits == -1){
   CMFS_perror("Had trouble reading data."); exit(1);
  }

  ABFWEIGHTS (a_in,beam_table,1,n,w);

}



