/******************************************************************************
*                                                                             *
*  vis.c - Generates standard Lofargram data for a set of time series data    *
*          by call VISSUB                                                     *
*                                                                             *
******************************************************************************/

#include <sys/types.h>
#include <cm/cm.h>
#include <cm/cm_stat.h>
#include <cm/cm_file.h>
#include <cm/cmfs.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <cm/paris.h>
#include <cm/cmssl-paris.h>

#define TRUE          1
#define FALSE         0

void main()

{
/******************************************************************************
*                                                                             *
*   Set-up variables                                                          *
*                                                                             *
******************************************************************************/
  char dv_fft_file_name[128],dv_bb_file_name[128];
  int dv_fftfile,dv_bbfile;
  int steps=32, out_channels=5;
  int i,sweep_count=0,step,channel;
  unsigned *fft_amp,fft_out, *bb_amp,bb_out;

/******************************************************************************
*                                                                             *
*   Initialize CM                                                             *
*                                                                             *
******************************************************************************/

  CM_init ();
  CMSSL_init ();
  CM_set_safety_mode (1);

/******************************************************************************
*                                                                             *
* Open DataVault files for output                                             *
*                                                                             *
******************************************************************************/

   strcpy (dv_fft_file_name,"vis.out");
  if ((dv_fftfile = CMFS_open(dv_fft_file_name, CMFS_O_RDWR | CM_CREAT, 0644,
      CM_physical_processors_limit,CM_user_number_of_processors_limit)) == -1){
            printf("error on dv file open: %s\n", dv_fft_file_name);
            exit(1);
       }
   strcpy (dv_bb_file_name,"bb.out");
  if ((dv_bbfile = CMFS_open(dv_bb_file_name, CMFS_O_RDWR | CM_CREAT, 0644,
      CM_physical_processors_limit,CM_user_number_of_processors_limit)) == -1){
            printf("error on dv file open: %s\n", dv_bb_file_name);
            exit(1);
       }

   VISBBSUB (&fft_amp,&bb_amp,TRUE,TRUE);
   fft_out=CM_allocate_stack_field(8*out_channels*steps);     
   bb_out=CM_allocate_stack_field(8*steps);     
   for(step = 0; step < steps; step++){
     VISBBSUB (&fft_amp,&bb_amp,FALSE,TRUE);
/******************************************************************************
*                                                                             *
*  Prepare data for out to DataVault and when output buffer full dump to      *
*  DataVault                                                                  *
*                                                                             *
******************************************************************************/

      CM_u_move_1L (fft_out+8*out_channels*step,fft_amp,8*out_channels);
      for(channel = 0; channel < out_channels; channel++){
         CMFS_transpose_always(fft_out+8*out_channels*step+8*channel,
             8,CMFS_IO_WRITE_TO_SERIAL_DATA,CMFS_write_to_column_major);
        }
    CM_u_move_1L (bb_out+8*step,bb_amp,8);
    CMFS_transpose_always(bb_out+8*step,8,CMFS_IO_WRITE_TO_SERIAL_DATA,NULL);
   }   /* end of for step */
    SAVE_AMPLITUDE(fft_out,0,dv_fftfile,out_channels*steps);
    SAVE_AMPLITUDE(bb_out,0,dv_bbfile,steps);
}

