/*

    wrf -  Dumps to the default output device the contents of 
           a portion of CM memory.  The output format is floating
           point. Calling sequence is

       wrf ( temp, start, stop  ,man, exp)

   where

       temp   -  Pointer to data slice in CM memory
       start  -  Starting PE ( processing element) number
       stop   -  Ending PE number
       man    -  Number of bits per PE in the mantissa of the number
       exp    -  Number of bits per PE in the exponent of the number

*/

#include <cm/paris.h>
#include <stdio.h>

void wrf (temp,start,stop,man,exp)
unsigned temp,start,stop;
int man,exp;

{
   unsigned i,istep,j;
   istep=5;
    for (i= start; i< stop; i+= istep) {
     for (j=0; j<istep; j++) {
      printf ("%g  ", CM_f_read_from_processor_1L(i+j,temp,man,exp));
     }
      printf (" \n");
   }
 }
