/******************************************************************************
*                                                                             *
*  vis.c - Generates standard Lofargram data for a set of time series data    *
*          by call VISSUB                                                     *
*                                                                             *
******************************************************************************/

#define TRUE          1
#define FALSE         0
#define DVFILE int

#include <sys/types.h>
#include <cm/cm.h>
#include <cm/cm_stat.h>
#include <cm/cm_file.h>
#include <cm/cmfs.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <cm/paris.h>
#include <cm/cmssl-paris.h>

void main(argc, argv)
     int argc;
     char **argv;
{
/******************************************************************************
*                                                                             *
*   Set-up variables                                                          *
*                                                                             *
******************************************************************************/
  char dv_out_file_name[128];
  DVFILE dv_outfile;
  int steps=121, nproc=8192, pts=4096, out_channels=15;
  int ncut=1, copy, i,sweep_count=0,step,channel;
  unsigned *fft_amp,amp_out;

/******************************************************************************
*                                                                             *
*   Initialize CM                                                             *
*                                                                             *
******************************************************************************/

  CM_init ();
  CMSSL_init ();
  CM_set_safety_mode (1);

/******************************************************************************
*                                                                             *
* Open DataVault files for output                                             *
*                                                                             *
******************************************************************************/
   strcpy (dv_out_file_name,"vis.out");
  if ((dv_outfile = CMFS_open(dv_out_file_name, CMFS_O_RDWR | CM_CREAT, 0644,
      CM_physical_processors_limit,CM_user_number_of_processors_limit)) == -1){
            printf("error on dv file open: %s\n", dv_out_file_name);
            exit(1);
       }
 printf ("%d \n",fft_amp);
 VISSUB (&fft_amp);
 printf ("%d \n",fft_amp);
  amp_out=CM_allocate_stack_field(8*out_channels*steps);     
    for(step = 0; step < steps; step++){
     VISSUB (&fft_amp);
   
/******************************************************************************
*                                                                             *
*  Prepare data for out to DataVault and when output buffer full dump to      *
*  DataVault                                                                  *
*                                                                             *
******************************************************************************/

         CM_u_move_1L (amp_out,fft_amp,8*out_channels);
      for(channel = 0; channel < out_channels; channel++){
         CMFS_transpose_always(amp_out+8*channel,
             8,CMFS_IO_WRITE_TO_SERIAL_DATA,CMFS_write_to_column_major);
        }
    SAVE_AMPLITUDE(amp_out,0,dv_outfile,out_channels);
      sweep_count += 1;
   }   /* end of for step */
    

    CMFS_close(dv_outfile);
}
