#include <geodata_private.h>
#include <stdio.h>
#include <ci/library.h>

/* this program uses the client interface to libgeodata to do the same
   thing the shore.gl script does using the Glisp interface */

main()
{

  GI_proj_desc *proj; 
  GB_id scene;
  GB_id display;

  /* initialize the CM and Geodata */
  CM_init();
  GI_init(0);

  /* get the appropriate scene */
  scene = GI_get_scene_id ("riv_shore_bound_scene");

  /* change the projection and projection parameters associated with
     the scene */
  /* latitude and longitude in radians; altitude in earth_radii */
  proj=GI_globe_view( 0.6783173, -1.344495, 2.4, GD_EARTH_RADII, 0.0, 0.0);
  GI_set_scene_projection(scene,proj);

  /* allocate a CM framebuffer type display */
  display=GI_create_display("my_display","",GS_CMFB,1024,1024); 
  
  /* render the scene */
  GI_update_scene(scene); 

  /* display the scene */
  GI_display_scene(display,scene,0,0);
}

