#include <geodata_private.h>
#include <stdio.h>
#include <ci/library.h>

main()
{
  GB_id scene;
  GB_id display;
  GI_proj_desc *proj;
  int color[3];
  char tmp[80];

  CM_init();
  GI_init(0);

  /* get the appropriate scene */
  scene = GI_get_scene_id ("shoreline_scene");

  /* allocate a CM framebuffer type display */
  display=GI_create_display("my_display","",GS_CMFB,1024,1024); 
  

  /* play with projections try each one and run parameters through zero
     points and extremes */

  proj=GI_miller();
  GI_set_scene_projection(scene,proj);
  GI_update_scene(scene);
  GI_display_scene(display,scene,0,0);

  proj=GI_scaled_geographics();
  GI_set_scene_projection(scene,proj);
  GI_update_scene(scene);
  GI_display_scene(display,scene,0,0);

  proj=GI_np_stereo();
  GI_set_scene_projection(scene,proj);
  GI_update_scene(scene);
  GI_display_scene(display,scene,0,0);

  proj=GI_sp_stereo();
  GI_set_scene_projection(scene,proj);
  GI_update_scene(scene);
  GI_display_scene(display,scene,0,0);

  GI_set_scene_height(scene,512);
  GI_set_scene_width(scene,512);

  /* lat,lon in rads */
/*
  proj=GI_gnomonic(0.0,0.0);
  GI_set_scene_projection(scene,proj);
  GI_update_scene(scene);
  GI_display_scene(display,scene,0,0);

  proj=GI_gnomonic( GS_PI/2.0 , GS_PI );
  GI_set_scene_projection(scene,proj);
  GI_update_scene(scene);
  GI_display_scene(display,scene,0,512);

  proj=GI_gnomonic( GS_PI/2.0 , 0.0 );
  GI_set_scene_projection(scene,proj);
  GI_update_scene(scene);
  GI_display_scene(display,scene,512,0);

  proj=GI_gnomonic( 0.0 , GS_PI );
  GI_set_scene_projection(scene,proj);
  GI_update_scene(scene);
  GI_display_scene(display,scene,512,512);
*/
  /* lon in rads */
  proj=GI_mollweide(0.0);
  GI_set_scene_projection(scene,proj);
  GI_update_scene(scene);
  GI_display_scene(display,scene,0,0);

  proj=GI_mollweide(GS_PI);
  GI_set_scene_projection(scene,proj);
  GI_update_scene(scene);
  GI_display_scene(display,scene,512,0);

  proj=GI_mollweide(-GS_PI);
  GI_set_scene_projection(scene,proj);
  GI_update_scene(scene);
  GI_display_scene(display,scene,0,512);

  GI_resize_scene(scene,1024,1024);

  /* x_from,y_from,z_from,x_to,y_to,z_to,x_up,y_up,z_up,fov,hither,yon */
  /* from,to and up in earth_radii; fov in degrees hither and yon clipping
     planes in earth_radii */
  proj=GI_general_perspective(1.5, 1.5, 1.0,
			      0.0, 0.0, 0.0, 
			       1.0, 1.0, 1.0,
			      40.0, 0.01, 2.0);
  GI_set_scene_projection(scene,proj);
  GI_update_scene(scene);
  GI_display_scene(display,scene,0,0);

  proj=GI_general_perspective(1.5, 1.5, 1.0,
			      0.1, 0.1, 0.0, 
			       1.0, 1.0, -1.0,
			      40.0, 0.01, 2.0);
  GI_set_scene_projection(scene,proj);
  GI_update_scene(scene);
  GI_display_scene(display,scene,0,0);


  GI_resize_scene(scene,512,512);

  /* lat,lon,alt,units,gamma,omega */
  /* lat and lon in radians; alt in units; gamma and omega in radians */

  proj=GI_globe_view( 0.0, 0.0, 20000.0, GD_KM, 0.0, 0.0);
  GI_set_scene_projection(scene,proj);
  GI_update_scene(scene);
  GI_display_scene(display,scene,0,0);

  proj=GI_globe_view( 0.0, GS_PI, 20000.0, GD_KM, 0.0, 0.0);
  GI_set_scene_projection(scene,proj);
  GI_update_scene(scene);
  GI_display_scene(display,scene,512,0);

  proj=GI_globe_view( GS_PI/2.0, 0.0, 20000.0, GD_KM, 0.0, 0.0);
  GI_set_scene_projection(scene,proj);
  GI_update_scene(scene);
  GI_display_scene(display,scene,0,512);

  proj=GI_globe_view( GS_PI/2.0, GS_PI, 20000.0, GD_KM, 0.0, 0.0);
  GI_set_scene_projection(scene,proj);
  GI_update_scene(scene);
  GI_display_scene(display,scene,512,512);

  proj=GI_globe_view( 0.0, 0.0, 2.5, GD_EARTH_RADII, 0.0, 0.0);
  GI_set_scene_projection(scene,proj);
  GI_update_scene(scene);
  GI_display_scene(display,scene,0,0);

  proj=GI_globe_view( 0.0, 0.0, 20000.0, GD_KM, GS_PI/2.0, 0.0);
  GI_set_scene_projection(scene,proj);
  GI_update_scene(scene);
  GI_display_scene(display,scene,512,0);

  proj=GI_globe_view( 0.0, 0.0, 20000.0, GD_KM, 0.0, 0.3);
  GI_set_scene_projection(scene,proj);
  GI_update_scene(scene);
  GI_display_scene(display,scene,0,512);

}

