#include <geodata_private.h>
#include <stdio.h>
#include <ci/library.h>

/* This program displays the riv_shore_bound scene which is defined in
   lib/scenes.gl, one of the GLisp files read when GI_init() is called. */

/* First the scene is shown as it is recorded, then the projection parameters
   associated with it are modified. For a complete rundown on projections and
   projection parameters SEE: projections.c */

main()
{
  GI_proj_desc *proj; 
  GB_id scene;
  GB_id display;

  /* initialize the CM and Geodata */
  CM_init();
  GI_init(0);

  /* get the appropriate scene */
  scene = GI_get_scene_id ("riv_shore_bound_scene");

  /* allocate a CM framebuffer type display */
  display=GI_create_display("my_display","",GS_CMFB,1024,1024); 
  
  /* render the scene */
  GI_update_scene(scene); 

  /* display the scene */
  GI_display_scene(display,scene,0,0);

  sleep(30);

  /* change the projection and projection parameters associated with
     the scene */
  /* latitude and longitude in radians; altitude in earth_radii */
  proj=GI_globe_view( 0.6783173, -1.344495, 2.4, GD_EARTH_RADII, 0.0, 0.0);
  GI_set_scene_projection(scene,proj);

  /* re-render the scene */
  GI_update_scene(scene); 

  /* display the scene */
  GI_display_scene(display,scene,0,0);

}

