#include "pgl_internal.h"


void PGL_clip (dest,point,type,length,min,max)
     CM_field_id_t dest,point;
     unsigned type,length,min,max;
{
  switch (type){
  case PGL_float:
    CM_f_ge_constant_1L (point,(float)min,S(length),E(length));
    CM_logand_2_1L (dest,CM_test_flag,1);
    CM_f_le_constant_1L (point,(float)max,S(length),E(length));
    CM_logand_2_1L (dest,CM_test_flag,1);
    break;
    
  case PGL_signed:
    CM_s_ge_constant_1L (point,min,length);
    CM_logand_2_1L (dest,CM_test_flag,1);
    CM_s_le_constant_1L (point,max,length);
    CM_logand_2_1L (dest,CM_test_flag,1);
    break;
    
  case PGL_unsigned:
    CM_u_ge_constant_1L (point,min,length);
    CM_logand_2_1L (dest,CM_test_flag,1);
    CM_u_le_constant_1L (point,max,length);
    CM_logand_2_1L (dest,CM_test_flag,1);
    break;
  }
}


void PGL_clip_point(dest,buffer,format,point)
     CM_field_id_t dest;
     PGL_buffer_t buffer;
     PGL_format_t format;
     CM_field_id_t point;
{
  PGL_clip (dest,PGL_extract(point,format,PGL_x),PGL_type(format,PGL_x),
	    PGL_length(format,PGL_x),0,buffer->width-1);
  PGL_clip (dest,PGL_extract(point,format,PGL_y),PGL_type(format,PGL_y),
	    PGL_length(format,PGL_y),0,buffer->height-1);
  PGL_clip (dest,PGL_extract(point,format,PGL_z),PGL_type(format,PGL_z),
	    PGL_length(format,PGL_z),0,buffer->depth-1);
}


/* assuming this always going to happen in float, this
   type independent garbage is a little sick*/

#define P_LENGTH 32
#define P_TYPE PGL_float

/* this will have to move the the existing lovely
   parallel line to serial line intersection to
   parallel line to parallel point*/
  
void PGL_intersection_constant (dest,format,p1,p2,x3,y3,x4,y4)
     CM_field_id_t dest;
     PGL_format_t format;
     CM_field_id_t p1,p2;
     int x3,y3,x4,y4;
{
  unsigned xl=PGL_length(format,PGL_x);
  unsigned yl=PGL_length(format,PGL_y);
  unsigned zl;
  unsigned xt=PGL_type(format,PGL_x);
  unsigned yt=PGL_type(format,PGL_y);
  unsigned zt;
  CM_field_id_t p=CM_allocate_stack_field(P_LENGTH);
  CM_field_id_t q=CM_allocate_stack_field(P_LENGTH);
  CM_field_id_t temp=CM_allocate_stack_field(P_LENGTH);
  CM_field_id_t temp2=CM_allocate_stack_field(P_LENGTH);

  if (PGL_find_name(format,PGL_z)){
    zl=PGL_length(format,PGL_z);
    zt=PGL_type(format,PGL_z);
  }

  PGL_cast (temp2,PGL_extract(p1,format,PGL_y),
	    P_TYPE,PGL_type(format,PGL_y),
	    P_LENGTH,PGL_length(format,PGL_y));
  CM_f_add_const_mult_const_1L (temp2,temp2,-(float)y3,(float)(x4-x3),
				S(P_LENGTH),E(P_LENGTH));
  
  PGL_cast (p,PGL_extract(p1,format,PGL_x),
	    P_TYPE,PGL_type(format,PGL_x),
	    P_LENGTH,PGL_length(format,PGL_x));
  CM_f_add_const_mult_const_1L (p,p,-(float)x3,(float)(y4-y3),
				S(P_LENGTH),E(P_LENGTH));
  CM_f_subfrom_2_1L (p,temp2,S(P_LENGTH),E(P_LENGTH));
  
  

  PGL_subtract_3_2L (q,PGL_extract(p2,format,PGL_x),
		     PGL_extract(p1,format,PGL_x),
		     P_TYPE,PGL_type(format,PGL_x),
		     P_LENGTH,PGL_length(format,PGL_x));
  
  PGL_subtract_3_2L (temp,PGL_extract(p2,format,PGL_y),
		     PGL_extract(p1,format,PGL_y),
		     P_TYPE,PGL_type(format,PGL_y),
		     P_LENGTH,PGL_length(format,PGL_y));
  
  CM_f_multiply_constant_2_1L (q,(float)(y4-y3),S(P_LENGTH),E(P_LENGTH));
  CM_f_mult_const_subf_1L (q,temp,(float)(x4-x3),q,S(P_LENGTH),E(P_LENGTH));
  

  CM_logand_3_1L (temp,CM_add_offset_to_field_id(p,P_LENGTH-1),
		  CM_add_offset_to_field_id(q,P_LENGTH-1),1);
  CM_logand_2_1L (dest,temp,1);

  PGL_gt (p,q,P_TYPE,P_LENGTH);
  CM_logxor_constant_3_1L (temp,CM_test_flag,1,1);
  CM_logand_2_1L (dest,temp,1);
  
  CM_logior_2_1L (dest,CM_test_flag,1);
  CM_logxor_3_1L (dest,CM_add_offset_to_field_id(p,P_LENGTH-1),
		  CM_add_offset_to_field_id(q,P_LENGTH-1),1);
  
  CM_f_mult_add_1L(p,p,temp,temp2,S(P_LENGTH),E(P_LENGTH));
  CM_f_mult_const_add_const_1L (q,q,(float)(y4-y3),(float)(y3),
				S(P_LENGTH),E(P_LENGTH));
  
  CM_logand_3_1L (temp,CM_add_offset_to_field_id(p,P_LENGTH-1),
		  CM_add_offset_to_field_id(q,P_LENGTH-1),1);
  CM_logand_2_1L (dest,temp,1);
  PGL_gt (p,q,P_TYPE,P_LENGTH);
  CM_logxor_constant_3_1L (temp,CM_test_flag,1,1);
  CM_logand_2_1L (dest,temp,1);
  CM_deallocate_stack_through(p);
}

/* put in test for z*/
void PGL_clip_line(dest,buffer,format,p1,p2)
     CM_field_id_t dest;
     PGL_buffer_t buffer;
     PGL_format_t format;
     CM_field_id_t p1,p2;
{
  CM_field_id_t temp = CM_allocate_stack_field(1);
  CM_field_id_t temp2 = CM_allocate_stack_field(1);

  CM_store_context(temp2);
  PGL_intersection_constant (temp2,format,p1,p2,0,0,0,buffer->height);
  CM_store_context(temp);
  PGL_intersection_constant (temp,format,p1,p2,0,0,buffer->width,0);
  CM_logior_2_1L (temp2,temp,1);
  CM_store_context(temp);
  PGL_intersection_constant (temp,format,p1,p2,buffer->width,0,
			     buffer->width,buffer->height);
  CM_logior_2_1L (temp2,temp,1);
  CM_store_context(temp);
  PGL_intersection_constant (temp,format,p1,p2,0,buffer->height,
			     buffer->width,buffer->height);
  CM_logior_2_1L (temp2,temp,1);

  CM_store_context(temp);
  PGL_clip_point(temp,buffer,format,p1);
  CM_logior_2_1L (temp2,temp,1);
  
  CM_store_context(temp);
  PGL_clip_point(temp,buffer,format,p2);
  CM_logior_2_1L (temp2,temp,1);
  
  CM_u_move_1L (dest,temp2,1);
/*  CM_store_context(dest);*/
  CM_deallocate_stack_through(temp);
}

