#include "pgl_internal.h"

static unsigned colors[]={PGL_r,PGL_g,PGL_b};

void PGL_onto(x1,x2,format)
     CM_field_id_t x1,x2;
     PGL_format_t format;
{
  CM_field_id_t o1=CM_allocate_stack_field(32);
  CM_field_id_t o2=CM_allocate_stack_field(32);
  CM_field_id_t t1=CM_allocate_stack_field(32);
  CM_field_id_t t2=CM_allocate_stack_field(32);
  CM_field_id_t entry_context=CM_allocate_stack_field(1);
  
  int i;
  CM_store_context(entry_context);

  PGL_extract_float_range (o1,x1,format,PGL_O,32);
  PGL_extract_float_range (o2,x2,format,PGL_O,32);
  CM_f_subf_const_mult_1L (o1,o2,1.0,o1,23,8);
  for (i=0;i<3;i++){
    PGL_extract_copy(t1,x1,format,colors[i],PGL_float,32);
    PGL_extract_copy(t2,x2,format,colors[i],PGL_float,32);
    
    CM_f_multiply_2_1L (t2,o2,23,8);
    CM_f_mult_add_1L (t1,t1,o1,t2,23,8);
    CM_f_add_3_1L (t2,o1,o2,23,8);
    CM_f_ne_zero_1L (t2,23,8);
    CM_logand_context_with_test();
    CM_f_divide_2_1L (t1,t2,23,8);
    CM_invert_context();
    CM_logand_context(entry_context);
    CM_f_move_zero_1L(t1,23,8);
    CM_load_context(entry_context);
    
    PGL_cast (PGL_extract(x1,format,colors[i]),t1,
	      PGL_type(format,colors[i]),PGL_float,
	      PGL_length(format,colors[i]),32);
  }  
  CM_f_add_2_1L (o1,o2,23,8);
  PGL_insert_float_range (x1,o1,format,PGL_O,32);
  CM_deallocate_stack_through(o1);
}


void PGL_overwrite_combine (dest,source)
     PGL_buffer_t dest,source;
{
  PGL_change_format (dest,source,dest->format,source->format);
}


static function_pointer combines[]={
  PGL_overwrite_combine,
  PGL_overwrite_combine,
  PGL_overwrite_combine,
  PGL_overwrite_combine,
  PGL_overwrite_combine,
  PGL_overwrite_combine,
  PGL_overwrite_combine,
  PGL_overwrite_combine
};
/*
#ifdef SGI_RENDER
PGL_sgi_extract
#endif
};
*/

void PGL_combine_buffer(dest,source,format,preshuffled_t)
     CM_field_id_t dest;
     PGL_buffer_t source;
     char *format;
     unsigned preshuffled_t;
{
  PGL_format_t ef = (PGL_format_t)PGL_translate_format(format);
  (*(combines[source->combiner]))(dest,source,ef,preshuffled_t);
  PGL_free_format(ef);
}

