#include "pgl_internal.h"

extern PGL_fill_line();

void PGL_plot_contour(dest,value,flags,format_string,point)
     PGL_buffer_t dest;
     float value;
     unsigned flags;
     char *format_string;
     CM_field_id_t point;
{
  int i,j,axis,inverse,axes[2];
  PGL_format_t format=PGL_translate_format(format_string);
  PGL_format_t i_format= PGL_generate_transfer_format(dest,format,flags);
  unsigned point_length = PGL_point_length(i_format);
  PGL_spawn_frame_t frame;
  CM_field_id_t cflags=CM_allocate_stack_field(10);
  CM_field_id_t state=CM_add_offset_to_field_id(cflags,6);
  CM_field_id_t x=CM_allocate_stack_field(point_length);
  CM_field_id_t y=CM_allocate_stack_field(point_length);
  CM_field_id_t z=CM_allocate_stack_field(point_length);
  CM_field_id_t t=CM_allocate_stack_field(32);
  CM_field_id_t t2=CM_allocate_stack_field(32);
  CM_field_id_t entry_context=CM_allocate_stack_field(1);
  CM_field_id_t pvalue=CM_allocate_stack_field(32);
  CM_field_id_t line[2];

  if (flags & PGL_fortran_geometry){
    axes[0]=1;axes[1]=2;
  }else{
    axes[0]=0;axes[1]=1;
  }

  line[0]=CM_allocate_stack_field(point_length*2);
  line[1]=CM_add_offset_to_field_id(line[0],point_length);

  CM_store_context(entry_context);  
  CM_set_context();

  /* this could actually use news normals*/
  PGL_generate_transfer_field(x,point,dest,i_format,format,flags,0);
  PGL_extract_copy(pvalue,point,format,PGL_v,PGL_float,32);
  CM_f_lt_constant_1L (pvalue,value,23,8);
  CM_store_test(state);
  CM_get_from_news_always_1L (state+1,state,axes[0],CM_upward,1);
  CM_get_from_news_always_1L (state+2,state,axes[1],CM_upward,2);
  for (i=0;i<3;i++){
    if (i<2) CM_u_move_1L (CM_add_offset_to_field_id(cflags,4-(i*2)),
			   CM_add_offset_to_field_id(state,3-(i*2)),1);
    for (j=0;j<(3-i);j++)
      CM_logxor_2_1L (CM_add_offset_to_field_id(state,j),
		      CM_add_offset_to_field_id(state,3-i),1);
    if (i<2) CM_u_move_1L (CM_add_offset_to_field_id(cflags,3-(i*2)),
			   CM_add_offset_to_field_id(state,2-(i*2)),1);
  }
  CM_u_move_1L (cflags,state,1);
  CM_u_eq_constant_1L (cflags,15,4);
  CM_logand_context_with_test();
  CM_store_context (CM_add_offset_to_field_id(cflags,5));
  CM_logxor_constant_3_1L (CM_add_offset_to_field_id(cflags,1),
			   CM_add_offset_to_field_id(cflags,4),0,1);
  CM_logxor_constant_3_1L (CM_add_offset_to_field_id(cflags,2),
			   CM_add_offset_to_field_id(cflags,4),1,1);
  CM_u_move_zero_1L (cflags,1);    
  CM_set_context();

  /* can eliminiate a 32 bit temporary here and possible a point_len temp*/
  CM_f_subfrom_constant_3_1L (t,pvalue,value,23,8);
  for (axis=0;axis<2;axis++){
    inverse = (axis)?0:1;
    CM_get_from_news_always_1L (t2,pvalue,axes[axis],CM_upward,32);
    CM_f_subtract_2_1L (t2,pvalue,23,8);
    CM_get_from_news_always_1L (z,x,axes[axis],CM_upward,point_length);
    PGL_interpolate_field(y,x,z,i_format,t,t2,PGL_float,32);
    CM_load_context (CM_add_offset_to_field_id(cflags,2+inverse));
    CM_get_from_news_1L(line[inverse],y,axes[inverse],CM_upward,point_length);
    CM_logand_context (CM_add_offset_to_field_id(cflags,axis));
    CM_u_move_1L (line[axis],y,point_length); 
    CM_invert_context();
    CM_logand_context (CM_add_offset_to_field_id(cflags,axis));
    CM_u_move_1L (line[inverse],y,point_length); 
    CM_set_context();
  }
  CM_u_gt_zero_1L (cflags,4);
  CM_logand_context_with_test();
  CM_logand_context(entry_context);
  frame=PGL_open_spawn(dest,PGL_fill_line,i_format,8192,2*point_length,flags);
/*  PGL_clip_line (CM_context_flag,dest,i_format,line[0],line[1]);*/
  PGL_screen_distance (pvalue,line[0],line[1],PGL_signed,32,i_format);
/*  PGL_print_field(line[0],i_format);
  PGL_print_field(line[1],i_format);*/
  PGL_write_spawn(frame,pvalue,line[0]);
/*  PGL_flush_spawn(frame);*/
  
  CM_load_context (CM_add_offset_to_field_id(cflags,5));    
  CM_get_from_news_1L (line[1],line[1],axes[1],CM_downward,point_length);
  CM_logand_context (CM_add_offset_to_field_id(cflags,4));
  CM_get_from_news_1L (line[0],y,axes[0],CM_upward,point_length);
  CM_invert_context();
  CM_logand_context(CM_add_offset_to_field_id(cflags,5)); 
  CM_get_from_news_1L (line[0],line[0],axes[0],CM_downward,point_length);
  CM_load_context (CM_add_offset_to_field_id(cflags,5));    
  CM_logand_context(entry_context);
/*  PGL_clip_line (CM_context_flag,dest,i_format,line[0],line[1]);*/
  PGL_screen_distance (pvalue,line[0],line[1],PGL_signed,32,i_format);
/*  PGL_print_field(line[0],i_format);
  PGL_print_field(line[1],i_format);*/

  PGL_write_spawn(frame,pvalue,line[0]);
  PGL_close_spawn(frame);
  CM_load_context(entry_context);
  CM_deallocate_stack_through(cflags);
}

