#include "pgl_internal.h"
#include <stdio.h>

void PGL_queue_extract()
{
}


void PGL_overwrite_extract(dest,source,format,preshuffled_t)
     CM_field_id_t dest;
     PGL_buffer_t source;
     PGL_format_t *format;
     unsigned preshuffled_t;
{
  CM_vp_set_id_t entry_vp_set = CM_current_vp_set;
  unsigned axes[2],zero[2];
  unsigned point_length = PGL_point_length(format);
  CM_field_id_t temp,entry_context;

  axes[0]=0;
  axes[1]=1;
  zero[0]=zero[1]=(CM_no_axis);
  
  CM_set_vp_set (source->vp_set);

  temp =CM_allocate_stack_field(point_length);
  entry_context = CM_allocate_stack_field(1);
  CM_store_context(entry_context);
  CM_set_context();
  PGL_change_format(temp,source->field,format,source->format);
  if ((source->preshuffled_t) &&(!preshuffled_t))
    CMFB_unshuffle_for_read (temp,temp,point_length);
  if (!(source->preshuffled_t) &&(preshuffled_t))
    CMFB_preshuffle_for_write (temp,temp,point_length);
  CM_cross_vp_move_always_1L (dest,temp,axes,zero,zero,point_length);
  CM_load_context(entry_context);
  CM_deallocate_stack_through(temp);
  CM_set_vp_set(entry_vp_set);
}

void PGL_voxel_extract(dest,source,format,preshuffled_t)
     CM_field_id_t dest;
     PGL_buffer_t source;
     PGL_format_t format;
     unsigned preshuffled_t;
{
  CM_vp_set_id_t entry_vp_set = CM_current_vp_set;

  unsigned axes[3],zero[3];
  unsigned point_length = PGL_point_length(format);
  unsigned s_point_length = PGL_point_length(source->format);
  CM_field_id_t temp,temp2,entry_context,address;
  unsigned zl=CM_geometry_coordinate_length(source->geometry,2);
  int i;

  axes[0]=0;
  axes[1]=1;
  axes[2]=(CM_no_axis);

  zero[0]=(CM_no_axis);
  zero[1]=(CM_no_axis);
  zero[2]=0;

  CM_set_vp_set (source->vp_set);  
  temp =CM_allocate_stack_field(s_point_length);
  temp2 =CM_allocate_stack_field(MAX(s_point_length,point_length));
  entry_context = CM_allocate_stack_field(1);
  address = CM_allocate_stack_field(32);
  
  CM_my_news_coordinate_1L (address,2,32);
  CM_store_context(entry_context);
  CM_u_move_1L (temp,source->field,s_point_length);
  CM_set_context();
  for (i=0;i<=zl;i++){
    CM_get_from_power_two_always_1L(temp2,temp,2,i,CM_upward,
				    s_point_length);
/*    CM_u_le_constant_1L (address,1<<(zl-i+1),32);*/
/*    CM_logand_context_with_test();*/
    PGL_onto (temp,temp2,source->format);
  }
  PGL_change_format(temp2,temp,format,source->format);
  CM_cross_vp_move_always_1L (dest,temp2,axes,zero,zero,point_length);
  CM_load_context(entry_context);

  CM_set_vp_set(entry_vp_set);
  if ((source->preshuffled_t) &&(!preshuffled_t))
    CMFB_unshuffle_for_read (dest,dest,point_length);
  if (!(source->preshuffled_t) &&(preshuffled_t))
    CMFB_preshuffle_for_write (dest,dest,point_length);
  CM_deallocate_stack_through(temp);
}

#ifdef SGI_RENDER
extern void PGL_sgi_extract();
#endif

static function_pointer extracts[]={
  PGL_overwrite_extract,
  PGL_overwrite_extract,
  PGL_queue_extract,
  PGL_overwrite_extract,
  PGL_voxel_extract,
#ifdef SGI_RENDER
  PGL_sgi_extract
#endif
  };


void PGL_extract_buffer(dest,source,format,preshuffled_t)
     CM_field_id_t dest;
     PGL_buffer_t source;
     char *format;
     unsigned preshuffled_t;
{
  PGL_format_t ef = (PGL_format_t)PGL_translate_format(format);
  (*(extracts[source->combiner]))(dest,source,ef,preshuffled_t);
  PGL_free_format(ef);
}

