#include "pgl_internal.h"

extern PGL_fill_triangle();
extern PGL_fill_line();

void PGL_plot_quadrilateral(dest,flags,format_string,p1,p2,p3,p4)
     PGL_buffer_t dest;
     unsigned flags;
     char *format_string;
     CM_field_id_t p1,p2,p3,p4;
{
  PGL_format_t format=PGL_translate_format(format_string,flags);
  PGL_format_t i_format=PGL_generate_transfer_format(dest,format,flags);
  unsigned point_length= PGL_point_length (i_format);
  CM_field_id_t args=CM_allocate_stack_field (3*point_length);
  CM_field_id_t x1=args;
  CM_field_id_t x2=CM_add_offset_to_field_id(args,point_length);
  CM_field_id_t x3=CM_add_offset_to_field_id(args,2*point_length);
  PGL_spawn_frame_t frame;
  
  frame=PGL_open_spawn (dest,PGL_fill_triangle,i_format,32768,
			3*point_length,flags);
  
  if (frame->flags & PGL_use_scan_lines)
    frame->next=PGL_open_scan_line(dest,i_format,2*point_length,flags);
  else
    frame->next=PGL_open_spawn(dest,PGL_fill_line,i_format,262144,
			       2*point_length,flags);

  PGL_generate_transfer_field(x1,p1,dest,i_format,format,flags,0);
  PGL_generate_transfer_field(x2,p2,dest,i_format,format,flags,0);
  PGL_generate_transfer_field(x3,p3,dest,i_format,format,flags,0);
  PGL_plot_triangle_internal (frame,dest,i_format,args);
  
  PGL_generate_transfer_field(x1,p4,dest,i_format,format,flags,0);
  PGL_plot_triangle_internal (frame,dest,i_format,args);

  PGL_flush_spawn (frame);
  if (frame->flags & PGL_use_scan_lines)
    PGL_close_scan_line (frame->next);
  else
    PGL_close_spawn(frame->next);
  PGL_close_spawn(frame);
  CM_deallocate_stack_through (args);
  PGL_free_format (i_format);
  PGL_free_format (format);
}



