#include "pgl_internal.h"
#include <math.h>

#define P_TYPE PGL_float
#define P_LENGTH 32

void PGL_send_sphere (dest,point,format)
     PGL_buffer_t dest;
     CM_field_id_t point;
     PGL_format_t format;
{
  PGL_format_t i_format =(PGL_format_t) PGL_copy_format(format);
  CM_field_id_t r = CM_allocate_stack_field(32);
  CM_field_id_t entry_context = CM_allocate_stack_field(1);
  CM_field_id_t tpoint,x,y,z,xp,yp,zp;
  int i,j,imax,jmax,rmax;
  float d,k;
  
  CM_store_context (entry_context);
  PGL_delete_format (&i_format,PGL_R);
  PGL_append_format (&i_format,PGL_X,P_TYPE,P_LENGTH,0,0);
  PGL_append_format (&i_format,PGL_Y,P_TYPE,P_LENGTH,0,0);
  PGL_append_format (&i_format,PGL_Z,P_TYPE,P_LENGTH,0,0);
  PGL_append_format (&i_format,PGL_x,P_TYPE,P_LENGTH,0,0);
  PGL_append_format (&i_format,PGL_y,P_TYPE,P_LENGTH,0,0);
  PGL_append_format (&i_format,PGL_z,P_TYPE,P_LENGTH,0,0);
  tpoint = CM_allocate_stack_field (PGL_point_length (i_format));
  x = PGL_extract (tpoint,i_format,PGL_X);
  y = PGL_extract (tpoint,i_format,PGL_Y);
  z = PGL_extract (tpoint,i_format,PGL_Z);
  xp = PGL_extract (tpoint,i_format,PGL_x);
  yp = PGL_extract (tpoint,i_format,PGL_y);
  zp = PGL_extract (tpoint,i_format,PGL_z);
  PGL_extract_copy (r,point,format,PGL_R,P_TYPE,P_LENGTH);
  
  PGL_change_format (tpoint,point,i_format,format);
  rmax = (int)(CM_global_f_max_1L (r,S(P_LENGTH),E(P_LENGTH)) + 1.0);
  for (i=(-rmax);i<rmax;i++)
    for (j=(-rmax);j<rmax;j++){

      /* kludged for a single radius active*/      
      d=sqrt((float)(i*i+j*j));      
      if (d < rmax){
	k=sqrt(((float)(rmax*rmax)-d*d));
	
	CM_f_ge_constant_1L (r,d,S(P_LENGTH),E(P_LENGTH));
	CM_logand_context_with_test();  
	
	PGL_extract_copy (xp,point,format,PGL_x,P_TYPE,P_LENGTH);
	PGL_extract_copy (yp,point,format,PGL_y,P_TYPE,P_LENGTH);
	PGL_extract_copy (zp,point,format,PGL_z,P_TYPE,P_LENGTH);
	
	
	CM_f_move_constant_1L (x,(float)i,S(P_LENGTH),E(P_LENGTH));
	CM_f_move_constant_1L (y,(float)j,S(P_LENGTH),E(P_LENGTH));
	CM_f_move_constant_1L (z,k,S(P_LENGTH),E(P_LENGTH));
	CM_f_add_constant_2_1L (xp,(float)i,S(P_LENGTH),E(P_LENGTH));
	CM_f_add_constant_2_1L (yp,(float)j,S(P_LENGTH),E(P_LENGTH));
	CM_f_add_constant_2_1L (zp,k,S(P_LENGTH),E(P_LENGTH));
	PGL_send(dest,tpoint,i_format);
	CM_load_context(entry_context);
      }
    }
  PGL_free_format (i_format);
  CM_deallocate_stack_through (r);
}


