#include "pgl_internal.h"
#include <cm/paris.h>

#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <stdio.h>


void append_width_data (dest_name,font)
    char *dest_name;
    XFontStruct *font;
{
 int i,j;
 FILE *out;
 XCharStruct *props=font->per_char;
 char temp;

 out=fopen(dest_name,"a");
 fprintf (out,"\nstatic char %s_widths[] = {\n",dest_name);
 for (i=0;i<96;i+=8){
   for (j=i;j<i+8;j++){
/*     temp=(char)(props[j].rbearing-props[j].lbearing);*/
     temp = (char)props[j].width;
     fprintf (out,"0x%x, ",temp);
   }
   fprintf (out,"\n");
 }
 fprintf (out,"};\n");
}

/*main (argc,argv)
   int argc;
   char** argv;*/
{ 
  Display *display;
  Pixmap my_pixmap;
  XImage *my_image;
  Drawable screen;
  XTextItem my_item;
  XFontStruct *my_font;
  GC my_gc;
  char x;
  char *font_name = argv[1];
  char *dest = argv[2];
  unsigned height,width,origin;

  if ((display= XOpenDisplay(NULL)) == NULL) 
    {printf ("display connect failed.\n");exit(1);}   

  if ((my_font = XLoadQueryFont(display,font_name)) == NULL){
    int i,k;
    char **fonts;
    
    printf ("did not find font in:\n");
    fonts=XGetFontPath(display,&k);
    for (i=0;i<k;i++)
      printf ("%s\n",fonts[i]);
    XFreeFontPath (fonts);
    fflush (stdout);
    exit(1);
  }   
  my_item.chars= (&x);
  my_item.nchars =1;
  my_item.font=my_font->fid;
  my_item.delta=0;
  width = my_font->max_bounds.rbearing-my_font->min_bounds.lbearing-1;
  origin = my_font->max_bounds.ascent;
  height = origin+my_font->max_bounds.descent;
  printf ("origin:%d height:%d width:%d\n",origin,height,width);
  my_pixmap = XCreatePixmap(display,XRootWindow
			    (display,XDefaultScreen(display)),
			    100*width,height,1);
  my_gc = XDefaultGCOfScreen(XDefaultScreenOfDisplay(display));
  for (x=32;x!=127;x++)
    XDrawText(display,my_pixmap,my_gc,(x-32)*width,origin,&my_item,1); 
  XWriteBitmapFile(display,dest,my_pixmap,96*width,height,-1,-1);
  append_width_data (dest,my_font);
}


int PGL_allocate_cm_font (font)
   char *font;
{
 CM_geometry_id_t font_geometry;
 CM_vp_set_id_t font_vp_set;
 unsigned dimensions,x_size=(font->char_x_size)*96,
 y_size =font->char_y_size,zero=0,other,actual,i;
 
 dimensions=PGL_next_power_2(x_size*y_size);
 actual=x_size*y_size;
 other = actual/8;
 font_geometry = CM_create_geometry (&dimensions,1);
 font_vp_set= CM_allocate_vp_set(font_geometry);
 font->field=CM_allocate_heap_field_vp_set (1,font_vp_set);

 CM_u_write_to_news_array_1L (font->memory,&zero,&zero,&actual,&zero,
			      font->field,1,1,&other,
			      CM_fe_packed_array_format(1,8));
 font->width_field = CM_allocate_heap_field_vp_set(8,CM_physical_vp_set());
 for (i=0;i<96;i++) 
   CM_u_write_to_processor_1L (i,font->width_field,(font->widths)[i],8); 
}

void PGL_deallocate_font ()
{
 CM_vp_set_id_t this_vp_set=CM_field_vp_set (PGL_current_font->field);
 CM_deallocate_heap_field(PGL_current_font->field);
 CM_deallocate_heap_field(PGL_current_font->width_field);
 CM_deallocate_geometry (CM_vp_set_geometry(this_vp_set));
 CM_deallocate_vp_set (this_vp_set);
}

void PGL_fill_char (frame)
     PGL_spawn_frame_t frame;
{
 char c;
 int i;
 CM_field_id_t xprime=CM_allocate_stack_field(32);
 CM_field_id_t otemp=CM_allocate_stack_field(32);
 CM_field_id_t yotemp=CM_allocate_stack_field(32);
 CM_field_id_t entry_context = CM_allocate_stack_field(1);
 CM_field_id_t this_char = array[2];

 CM_store_context (entry_context);
 CM_u_move_1L (xprime,array[0],32);
 CM_f_ge_constant_1L (this_char,1.0,23,8);
 CM_logand_context_with_test();
 for (i=0;CM_global_count_context();i++){
   PGL_plot_point
   if (p_no&1)
     PGL_plot(dest,PGL_points,PGL_character,xprime,array[1],this_char,array[3],
	      array[4],array[5]);
   else 
     PGL_plot(dest,PGL_points,PGL_character,xprime,array[1],
	      this_char,array[3]);
   CM_s_f_truncate_2_2L (otemp,this_char,32,23,8);
   CM_u_subtract_constant_2_1L (otemp,32,32);
   CM_get_1L (yotemp,otemp,PGL_current_font->width_field,8);
   CM_f_u_float_2_2L (otemp,yotemp,8,23,8);
   CM_f_add_2_1L (xprime,otemp,23,8);
   this_char = CM_add_offset_to_field_id(this_char,32);
   CM_f_ge_constant_1L (this_char,1.0,23,8);
   CM_logand_context_with_test();
   }   
 CM_load_context (entry_context);
 CM_deallocate_stack_through (xprime);    
}



void PGL_open_string()
{

}

void PGL_write_string()
{
}

void PGL_close_string()
{

}


void PGL_plot_string (dest,flags,font,format,string)
     PGL_buffer_t dest;
     unsigned flags,font;
     PGL_format_t format;
     char *string;
{
  CM_vp_set_id_t entry_vp_set = CM_current_vp_set;

  CM_set_vp_set(entry_vp_set);
}
