#include "pgl_internal.h"
#include <cm/cmfb.h>
#include <math.h>

extern double drand48();

unsigned x_dim,y_dim,z_depth,iterations,mutations,pause,point_rank,poly_rank;
unsigned vp_rank,vp_dimensions[4],display_type,count,point_length,frame_count;
unsigned item_count;
float speed,size;

char format[]="xf yf zf rf gf bf";

float bounds[10][2];
CM_field_id_t points[8];
CM_field_id_t velocities[8];
CM_vp_set_id_t vp_set;
PGL_buffer_t buffer;
PGL_display_t display;

void nothing()
{
}

void single_scan(dest)
{
  CM_u_write_to_processor_1L (1223,CM_context_flag,1,1);
  scanf ("%f %f %f %f %f");
}

#define TABLE_SAMPLES 25
#define RFREQ 1.0
#define RPHASE (M_PI/2.0)
#define GFREQ 1.0
#define GPHASE (M_PI/2.0+4.0*M_PI/3.0)
#define BFREQ 1.0
#define BPHASE (M_PI/2.0+2.0*M_PI/3.0)

void rainbow_colortable (slot)
     int slot;
{
  int i;
  float v;
/*  
  for (i=0;i<TABLE_SAMPLES;i++){
    v = (float)i/(float)TABLE_SAMPLES*2.0-1.0;
    PGL_add_color_entry(v,(unsigned char)(128.0*sin(v*RFREQ+RPHASE)+128),
			(unsigned char)(128.0*sin(v*GFREQ+GPHASE)+128),
			(unsigned char)(128.0*sin(v*BFREQ+BPHASE)+128));
    }
*/
}


/* these should be moved inside range and multiplied by 'size'*/
#define R 100.0
#define R0 150.0

void torus_fill()
{
  CM_field_id_t x,y,z,r,g,b;

  points[0]=CM_allocate_stack_field(point_length);
  x=points[0];
  y=CM_add_offset_to_field_id(x,32);
  z=CM_add_offset_to_field_id(y,32);

  CM_my_news_coordinate_1L (z,0,32);
  CM_f_u_float_2_2L (r,z,32,23,8);
  CM_my_news_coordinate_1L (z,1,32);
  CM_f_u_float_2_2L (g,z,32,23,8);
  CM_f_multiply_constant_2_1L (r,2.0*M_PI/(float)vp_dimensions[0],23,8);
  CM_f_multiply_constant_2_1L (g,2.0*M_PI/(float)vp_dimensions[1],23,8);
  
/*  CM_f_multiply_3_1L (color,x,y,23,8);
  CM_f_add_2_1L (color,z,23,8);
  CM_f_multiply_constant_2_1L (color,2.0*3.1415926535/(R*R+R0),23,8);*/
  
  /* get phi, etc from news grid directly*/
/*  CM_f_cos_2_1L (z,phi,23,8);
  CM_f_multiply_constant_2_1L (z,R0,23,8);
  CM_f_add_constant_2_1L (z,R,23,8);
  CM_f_cos_2_1L (x,theta,23,8);
  CM_f_multiply_2_1L(x,z,23,8);
  CM_f_sin_2_1L (y,theta,23,8);
  CM_f_multiply_2_1L(y,z,23,8);
  CM_f_sin_2_1L (z,phi,23,8);*/
  CM_f_multiply_constant_2_1L (z,R0,23,8);
}



void random_point()
{
  int i,j;
  CM_field_id_t temp;
  
  temp=CM_allocate_stack_field(32);
  CM_u_move_zero_always_1L (temp,32);
  CM_my_send_address_1L (temp,32);
  CM_u_lt_constant_1L (temp,item_count,32);
  CM_logand_context_with_test();

  for (i=0;i<poly_rank;i++){
    points[j]=CM_allocate_stack_field(32*point_rank);    
    for (i=0;i<point_rank;i++){
      CM_f_random_1L (points[j]+i*32,23,8);  
      CM_f_mult_const_add_const_1L (points[j]+i*32,points[j]+i*32,
				    (bounds)[i][1]-
				    (bounds)[i][0],
				    (bounds)[i][0],23,8);
    }
  }
}


void smooth ()
{
  
}


void wandering_setup (dest)
     CM_field_id_t *dest;
{
  int i,j;

  random_point(velocities);

  for (j=0;j<poly_rank;j++)
    for (i=0;i<point_rank;i++)
      CM_f_multiply_constant_2_1L(velocities[j]+i*32,speed,23,8);
  
}

void rotation()
{
}

void rotate_colors()
{
 /*  CM_f_multiply_constant_2_1L (PGL_extract_field(point,1.1,23,8);*/
}

void add_velocities()
{
  int i,j;
  CM_field_id_t entry_context= entry_context = CM_allocate_stack_field(1);

  CM_store_context(entry_context);
  for (j=0;j<poly_rank;j++)
    for (i=0;i<point_rank;i++){
      CM_f_add_2_1L (points[j]+i*32,velocities[j]+i*32,23,8);
      CM_f_le_constant_1L (points[j]+i*32,bounds[i][0],23,8);
      CM_logand_context_with_test();
      CM_f_subfrom_constant_2_1L (points[j]+i*32,bounds[i][0],23,8);
      CM_f_add_constant_2_1L (points[j]+i*32,bounds[i][0],23,8);
      CM_f_negate_1_1L (velocities[j]+i*32,23,8);
      CM_load_context(entry_context);
      
      
      CM_f_ge_constant_1L (points[j]+i*32,bounds[i][1],23,8);
      CM_logand_context_with_test();
      CM_f_subfrom_constant_2_1L (points[j]+i*32,bounds[i][1],23,8);
      CM_f_add_constant_2_1L (points[j]+i*32,bounds[i][1],23,8);
      CM_f_negate_1_1L (velocities[j]+i*32,23,8);
      CM_load_context(entry_context);
    }
  CM_deallocate_stack_through(entry_context);
}

void plot_point(buffer)
     PGL_buffer_t buffer;
{
  PGL_plot_point (buffer,format,points[0]);
}


void plot_line(buffer)
     PGL_buffer_t buffer;
{
  PGL_plot_line (buffer,format,points[0],points[1]);
}


void plot_triangle(buffer)
     PGL_buffer_t buffer;
{
  PGL_plot_triangle (buffer,format,points[0]);
}


void plot_quadrilateral(buffer)
     PGL_buffer_t buffer;
{
  PGL_plot_quadrilateral (buffer,format,points[0]);
}


void plot_surface(buffer)
     PGL_buffer_t buffer;
{
  PGL_plot_surface (buffer,format,points[0]);
}


void (*fill_function)();
void (*mutate_function)();
void (*plot_function)();
void (*shutdown_function)();


void set_defaults()
{
  vp_rank =1;
  vp_dimensions[0]=CM_physical_processors_limit;
  vp_dimensions[1]=1;
  vp_dimensions[2]=1;
  vp_dimensions[3]=1;
  x_dim=512;
  y_dim=512;
  z_depth=8;
  iterations=40;
  mutations=1;
  count =0;
  pause=0;
  point_rank=6;
  poly_rank=1;
  display_type=PGL_cmfb;
  size=1.0;
  speed=2.0;
  frame_count=1;
  fill_function=random_point;
  mutate_function=nothing;
  plot_function=plot_point;
  shutdown_function=nothing;  
}


void run_sentence()
{  
  int i,r,k,l;
  
  display=PGL_allocate_display(display_type,getenv("CM_FRAMEBUFFER"),
			       x_dim,y_dim);
  buffer =PGL_allocate_buffer(x_dim,y_dim,PGL_max,"ru8 gu8 bu8 zu16");
  
  PGL_translate_buffer(buffer,PGL_x,1.0);
  PGL_translate_buffer(buffer,PGL_y,-1.0);
  PGL_scale_buffer(buffer,PGL_x,x_dim/2.0);
  PGL_scale_buffer(buffer,PGL_y,y_dim/-2.0);

  CM_set_vp_set(CM_allocate_vp_set
		(CM_create_geometry(vp_dimensions,vp_rank)));  
  (*(fill_function))();
  for (r=0;r<mutations;r++){
    (*(mutate_function))();
    (*(plot_function))(buffer);
    PGL_display_buffer (display,buffer,0,0);
    PGL_clear_buffer(buffer);
    sleep(pause);
  }
  (*(shutdown_function))();
  PGL_deallocate_display(display);
  PGL_deallocate_buffer(buffer);
  CM_deallocate_geometry(CM_vp_set_geometry(CM_current_vp_set));
  CM_deallocate_vp_set(CM_current_vp_set);
}


int current_count()
{
  int temp=count;
  count=0;
  return(count);
}
 
    
void point()
{poly_rank=1;plot_function=plot_point;}

void line()
{poly_rank=2;plot_function=plot_line;}

void triangle()
{poly_rank=3;plot_function=plot_triangle;}

void quadrilateral()
{poly_rank=4;plot_function=plot_quadrilateral;}

void and()
{run_sentence();set_defaults();}     

void wandering()
{mutate_function=add_velocities;iterations=2;mutations=100;}

void coarse()
{x_dim=128;y_dim=128;}

void fine()
{x_dim=1024;y_dim=1024;}

void torus()
{vp_dimensions[0]=128;vp_dimensions[1]=256;
 plot_function=plot_surface;mutate_function=rotation;
 fill_function=torus_fill;}

void slow()
{speed=0.4;}

void fast()
{speed=5.0;}

void big()
{size=2.0;}

void little()
{size=0.5;}

void number(x)
     int x;
{count+=x;}

void frame()
{ frame_count = current_count();}

struct args{
  char name[30];
  void (*action)();
  int argument;
};


/* klein 
   knot 
   sphere
   flyby
   psychedelic
   wireframe
   */

struct args commands[]={
  {"point",point,0},
  {"line",line,0},
  {"triangle",triangle,0},
  {"quadrilateral",quadrilateral,0},
  {"wandering",wandering,0},
  {"coarse",coarse,0},
  {"fine",fine,0},
  {"and",and,0},
  {"torus",torus,0},
  {"big",big,0},
  {"little",little,0},
  {"fast",fast,0},
  {"slow",slow,0},
  {"one",number,1},
  {"two",number,2},
  {"three",number,3},
  {"four",number,4},
  {"five",number,5},
  {"six",number,6},
  {"seven",number,7},
  {"eight",number,8},
  {"nine",number,9},
  {"ten",number,10},
  {"twenty",number,20},
  {"thirty",number,30},
  {"fourty",number,40},
  {"fifty",number,40},
  {"sixty",number,60},
  {"seventy",number,70},
  {"eighty",number,80},
  {"ninety",number,90},
  {"hundred",number,100},     
  {"frame",frame,100},     
  {"",0,0}};


main(argc,argv)
     int argc;
     char **argv;
{
  int i;
  struct args *j;

  CM_init();
  set_defaults();
  for (i=1;i<argc;i++){
    j=commands;
    while (*(j->name)){
      if (strcmp(j->name,argv[i])==0)  (*(j->action))(j->argument);
      j++;
    }
  }
  run_sentence();
}

