#include "pgl_internal.h"


void PGL_cast (dest,source,d_type,s_type,d_len,s_len)
     CM_field_id_t dest,source;
     unsigned d_type,s_type;
     unsigned d_len,s_len;
{
  float max;
  CM_field_id_t temp;

  switch (d_type){
  case PGL_float:
    switch (s_type){
    case PGL_float:
      CM_f_move_2L (dest,source,S(d_len),E(d_len),S(s_len),E(s_len));
      break;
    case PGL_signed:
      CM_f_s_float_2_2L (dest,source,s_len,S(d_len),E(d_len));
      break;
    case PGL_unsigned:
      CM_f_u_float_2_2L (dest,source,s_len,S(d_len),E(d_len));
      break;
    }
    break;
    
  case PGL_signed:
    switch (s_type){
    case PGL_float:
     temp= CM_allocate_stack_field(s_len);
     CM_f_max_constant_3_1L (temp,source,-(float)((1<<d_len-1)-1),
			     S(s_len),E(s_len));
     CM_f_min_constant_2_1L (temp,(float)((1<<d_len-1)-1),
			     S(s_len),E(s_len));
     CM_s_f_truncate_2_2L (dest,source,d_len,S(s_len),E(s_len));
/*     CM_s_f_round_2_2L (dest,source,d_len,S(s_len),E(s_len));*/
     CM_deallocate_stack_through(temp);      
     break;
   case PGL_signed:
      CM_s_move_2L (dest,source,d_len,s_len);
     break;
   case PGL_unsigned:
     CM_u_move_2L (dest,source,d_len,s_len);
     break;
   }
    break;
    
  case PGL_unsigned:
    switch (s_type){
    case PGL_float:
      temp= CM_allocate_stack_field(s_len);
      CM_u_move_1L(temp,source,s_len);
      CM_f_min_constant_3_1L (temp,source,(float)((1<<d_len)-1),
			      S(s_len),E(s_len));
      CM_f_max_constant_2_1L (temp,0.0,S(s_len),E(s_len));
      CM_u_f_truncate_2_2L (dest,temp,d_len,S(s_len),E(s_len));
      CM_deallocate_stack_through(temp);
      break;
    case PGL_signed:
      CM_s_move_2L (dest,source,d_len,s_len);
      break;
    case PGL_unsigned:
      CM_u_move_2L (dest,source,d_len,s_len);
      break;
    }
    break;
  }
}

 

void PGL_broadcast (dest,source,d_type,s_type,d_len,s_len)
     CM_field_id_t dest;
     char *source;
     unsigned d_type,s_type;
     unsigned d_len,s_len;
{
  switch (d_type){
  case PGL_float:
    switch (s_type){
    case PGL_float:
      CM_f_move_constant_1L (dest,*((float*)source),S(d_len),E(d_len));
      break;
    case PGL_signed:
      CM_f_move_constant_1L (dest,(float)(*(int*)source),S(d_len),E(d_len));
      break;
    case PGL_unsigned:
      CM_f_move_constant_1L(dest,(float)(*(unsigned*)source),
			    S(d_len),E(d_len));
      break;
    }
    break;
    
  case PGL_signed:
    switch (s_type){
    case PGL_float:
      CM_s_move_constant_1L (dest,(int)(*(float*)source),d_len);
      break;
    case PGL_signed:
      CM_s_move_constant_1L (dest,(*(int*)source),d_len);
      break;
    case PGL_unsigned:
      CM_s_move_constant_1L(dest,(int)(*(unsigned*)source),d_len);
      break;
    }
    break;
    
  case PGL_unsigned:
    switch (s_type){
    case PGL_float:
      CM_u_move_constant_1L (dest,(unsigned)(*(float*)source),d_len);
      break;
    case PGL_signed:
      CM_u_move_constant_1L (dest,(unsigned)(*(int*)source),d_len);
      break;
    case PGL_unsigned:
      CM_u_move_constant_1L(dest,(*(unsigned*)source),d_len);
      break;
    }
    break;
  }
}



void PGL_gt (a,b,type,length)
     CM_field_id_t a,b;
     unsigned type,length;
{
  switch (type){
  case PGL_float:
    CM_f_gt_1L (a,b,S(length),E(length));
    break;
    
  case PGL_signed:
    CM_s_gt_1L (a,b,length);
    break;
    
  case PGL_unsigned:
    CM_u_gt_1L (a,b,length);
    break;
  }
}


void PGL_multiply_3_3L (a,b,c,at,bt,ct,al,bl,cl)
     CM_field_id_t a,b,c;
     unsigned at,bt,ct,al,bl,cl;
{
  CM_field_id_t temp = CM_allocate_stack_field(al);
  PGL_cast(a,b,at,bt,al,bl);
  PGL_cast(temp,c,at,ct,al,cl);
  switch (at){
  case PGL_float:
    CM_f_multiply_2_1L (a,temp,S(al),E(al));
    break;
  case PGL_signed:
    CM_s_multiply_2_1L (a,temp,al);
    break;
  case PGL_unsigned:
    CM_u_multiply_2_1L (a,temp,al);
    break;
  }
  CM_deallocate_stack_through(temp);
}

void PGL_subtract_2_1L (a,b,type,length)
     CM_field_id_t a,b;
     unsigned type,length;
{
  switch (type){
  case PGL_float:
    CM_f_subtract_2_1L (a,b,S(length),E(length));
    break;    
  case PGL_signed:
    CM_s_subtract_2_1L (a,b,length);
    break;    
  case PGL_unsigned:
    CM_u_subtract_2_1L (a,b,length);
    break;
  }
}


void PGL_subtract_3_2L (a,b,c,d_type,s_type,d_length,s_length)
     CM_field_id_t a,b,c;
     unsigned s_type,d_type;
     unsigned s_length,d_length;
{
  CM_field_id_t temp=CM_allocate_stack_field(s_length);
  switch (s_type){
  case PGL_float:
    CM_f_subtract_3_1L (a,b,c,S(s_length),E(s_length));
    break;
  case PGL_signed:
    CM_s_subtract_3_1L (a,b,c,s_length);
    break;
  case PGL_unsigned:
    CM_u_subtract_3_1L (a,b,c,s_length);
    break;
  }
  PGL_cast (a,temp,d_type,s_type,d_length,s_length);
  CM_deallocate_stack_through(temp);
}
