#include <geodata.h>
#include <geodata_private.h>
#include <math.h>

void GS_color_value (dest,source,from,to,what_varies)
     CM_field_id_t dest,source;
     GS_table_t from,to;
     unsigned what_varies;
{
  CM_field_id_t entry_context = CM_allocate_stack_field(1);
  CM_field_id_t temp = CM_allocate_stack_field(32);  
  CM_field_id_t t = CM_allocate_stack_field(32);  
  CM_field_id_t intensity = CM_allocate_stack_field(32);  
  GS_table_t only;
  int i,j;

  CM_store_context (entry_context);

  if ((what_varies != GS_COLOR_VARIES) ||  (from==(GS_table_t)0) ||
      (to==(GS_table_t)0)){
    if (from == (GS_table_t)0){
      only=to;
      CM_f_le_constant_1L (source,to->value,23,8);
      CM_logand_context_with_test();
    } else
      if (to == (GS_table_t)0){
	only=from;
	CM_f_ge_constant_1L (source,from->value,23,8);
	CM_logand_context_with_test();
      }  else  {
	only=from;
	CM_f_le_constant_1L (source,to->value,23,8);
	CM_logand_context_with_test();
	CM_f_ge_constant_1L (source,from->value,23,8);
	CM_logand_context_with_test();
      }
    for (j=0;j<3;j++)
      CM_u_move_constant_1L(CM_add_offset_to_field_id(dest,j*8),
			    only->color[j],8);
  } else {
    if (from->value > to->value)
      GB_message (GB_NOTIFY,"color generation","Table value ordering error");
    
    CM_f_ge_constant_1L (source,from->value,23,8);
    CM_logand_context_with_test();
    CM_f_lt_constant_1L (source,to->value,23,8);
    CM_logand_context_with_test();  
    CM_f_sub_const_mult_const_1L(t,source,to->value,
				 1.0/(float)(from->value-to->value),23,8);
    
    for (j=0;j<3;j++){
      CM_f_multiply_constant_3_1L (temp,t,(float)(from->color[j]-
						  to->color[j]),23,8);
      CM_f_add_constant_2_1L (temp,(float)(to->color[j]),23,8);
      CM_u_f_round_2_2L (CM_add_offset_to_field_id(dest,j*8),temp,8,23,8);
    }
  }
  CM_load_context(entry_context);
  CM_deallocate_stack_through (entry_context);  
}

