#include <geodata.h>
#include <geodata_private.h>

extern GS_symbol_open();
extern GS_symbol_write();
extern GS_symbol_close();

extern GS_line_open();
extern GS_line_write();
extern GS_line_close();

extern GS_area_open();
extern GS_area_write();
extern GS_area_close();

extern GS_area_contour_open();
extern GS_area_contour_write();
extern GS_area_contour_close();

extern GS_volume_open();
extern GS_volume_write();
extern GS_volume_close();

extern GS_volume_contour_open();
extern GS_volume_contour_write();
extern GS_volume_contour_close();

static GS_rep_func GS_rep_functions[]={
  {GS_symbol_open,GS_symbol_write,GS_symbol_close,0,0},
  {GS_line_open,GS_line_write,GS_line_close,0,0},
  {GS_area_open,GS_area_write,GS_area_close,1,2},
  {GS_area_contour_open,GS_area_contour_write,GS_area_contour_close,1,2},
  {GS_volume_open,GS_volume_write,GS_volume_close,1,3},
  {GS_volume_contour_open,GS_volume_contour_write,GS_volume_contour_close,8,3}
};

static CM_geometry_id_t edge_geometry;
static CM_vp_set_id_t edge_vp_set,edge_context;
static CM_field_id_t edges;
static unsigned edge_blocks[3];
static unsigned num_blocks;


void GS_open_rep (rep_code,dest,priority,blocks,memory,flags)
     unsigned rep_code;
     CM_field_id_t dest;
     unsigned priority;     
     unsigned *blocks;
     unsigned memory;
     unsigned flags;
{
  
  (*(GS_rep_functions[rep_code-GS_SYMBOL_REP]).open) (dest,priority,memory,flags);
}



void GS_write_rep (rep_code,data,rep,block)
     unsigned rep_code;
     CM_field_id_t data;
     GS_representation_t rep;
     unsigned *block;
{
  (*(GS_rep_functions[rep_code-GS_SYMBOL_REP].write))(data,rep);
}



void GS_close_rep (rep_code)
     unsigned rep_code;
{
  (*(GS_rep_functions[rep_code-GS_SYMBOL_REP].close))();
}

