
#include <cm/paris.h>
#include <cm/cmfs.h>
#include <cm/cm_file.h>
#include <stdio.h>

unsigned zero[]={0,0};
unsigned axis[]={1,0};

int move_to_fe (dvfile, fefile, width, height)
     char *dvfile, *fefile;
     int *width, *height;
{
  int fd;
  char filename[100];
  int index=0;
  CM_field_id_t field;
  unsigned dimensions[2];
  CM_geometry_id_t fg;
  int *fe_array;
  FILE *fout;
  int i,j, status;

  printf ("\nAttaching to CM\n");
  CM_init();
  printf ("Opening DV file %s\n", dvfile);
  if (fd=CMFS_open (dvfile, CMFS_O_RDONLY) < 0){
    CMFS_perror ("open failed");
    exit(1);
  }
  printf ("Opened DV file %s\n", dvfile);
  
  fg = (CM_geometry_id_t) CMFS_file_geometry (fd);
  *width = dimensions[0] = CM_geometry_axis_length (fg, 0);
  *height = dimensions[1] = CM_geometry_axis_length (fg, 1);
  CM_set_vp_set (CM_allocate_vp_set (CM_create_geometry (dimensions, 2)));
  field = CM_allocate_stack_field (32);
  fe_array = (int *) malloc (sizeof (int)*dimensions[0]*dimensions[1]);
  
  printf ("Reading DV file %s\n", dvfile);
  while (CMFS_read_file_always (fd,field,24) == 24) {
    sprintf (filename, "%s.%d", fefile, index++);
    printf ("Opening FE file %s\n", filename);
    if ((fout=fopen(filename,"w")) < 0) {
      perror ("fe open failed");
      exit(1);
    }
    CM_u_read_from_news_array_1L (fe_array,zero,zero,dimensions,axis,
				  field,32,2,dimensions,CM_32_bit);
    for (j=dimensions[1];j>0;j--)
      for (i=0;i<dimensions[0];i++){
#ifdef sparc	
	fwrite ((char *)(fe_array+((j-1)*dimensions[0])+i)+3,1,1,fout);
	fwrite ((char *)(fe_array+((j-1)*dimensions[0])+i)+2,1,1,fout);
	fwrite ((char *)(fe_array+((j-1)*dimensions[0])+i)+1,1,1,fout);
#else
	fwrite (fe_array+((j-1)*dimensions[0])+i,1,3,fout);
#endif 
      }
    fclose (fout); 
  }

  printf ("Done. Detaching.\n");
  CMFS_close (fd);
  printf ("Detaching from CM\n");
  CM_detach ();
  return (index);
}


void main(argc,argv)
     int argc;
     char **argv;
{
  int frames, i;
  int width, height;
  char command[256];

  frames = move_to_fe (argv[1], argv[2], &width, &height);
  for (i=0; i<frames; i++) {
    printf ("\nConverting %s.%d to tiff...\n", argv[2], i);
    sprintf (command, "pixtoppm %d %d %s.%d | pnmtotiff > %s.%d.tiff\n",
	     width, height, argv[2], i, argv[2], i);
    system (command);
  }
}
