
#include <math.h>
#include <stdio.h>

#define PI 3.1415927
#define EARTH_RADIUS 6371009.0
#define DEG2RAD 0.017453292

/*  Thses are the lat and lon of the point you are looking from and the point
 *  you are looking to.  Values such that the TO point is about 45 degrees
 *  away fromm the FROM point and the given altitudes seem to work well.
 */

#define SIZE 128

#define ST_F_LAT 45.0
#define ST_F_LON -180.0
#define END_F_LAT 20.0
#define END_F_LON 115.0

#define ST_T_LAT 40.0
#define ST_T_LON -145.0
#define END_T_LAT 15.0
#define END_T_LON 150.0

#define F_ALT 1.8
#define T_ALT 1.0001

#define FRAMES 60

void convert (lat,lon,alt,x,y,z)
     float lat, lon, alt;
     float *x, *y, *z;
{
  float rlat, rlon, rp;
  rlat = lat * DEG2RAD;
  rlon = lon * DEG2RAD;
  if ((alt >= 5.0) || (alt == 0.0))
    alt = (alt + EARTH_RADIUS) / EARTH_RADIUS;
  rp = alt * cos(rlat);
  *x = -rp * cos(rlon);
  *y = rp * sin(rlon);
  *z = alt * sin(rlat);
}


main (argc,argv)
     int argc;
     char **argv;
{
  float p1, p2, p3, p4, p5, p6, p7, p8, p9;
  float p10 = 50.0,  p11 = 0.1,  p12 = 2.5;
  float flat, flon, tlat, tlon;
  int i;

  printf ("(include IFOO (file \"/afs/cmf/geodata/@sys/test/glenn.gl\"))\n");
/*  printf ("(display DIS (display_type cmfb) (size 1024 1024))\n");*/
  printf
    ("(display DIS (display_type cmfs) (size %d %d) (name \"dv:%s.%d\"))\n",
     SIZE, SIZE, argv[1], SIZE);
  printf ("(scene demo_scene (dimensions %d %d))\n", SIZE, SIZE);

  for (i=0; i<FRAMES; i++) {
    flat = ST_F_LAT + (i * (END_F_LAT - ST_F_LAT) / (FRAMES - 1));
    flon = ST_F_LON + (i * (END_F_LON - ST_F_LON) / (FRAMES - 1));
    tlat = ST_T_LAT + (i * (END_T_LAT - ST_T_LAT) / (FRAMES - 1));
    tlon = ST_T_LON + (i * (END_T_LON - ST_T_LON) / (FRAMES - 1));

    convert (flat, flon, F_ALT, &p1, &p2, &p3);
    convert (tlat, tlon, T_ALT, &p4, &p5, &p6);
    convert (tlat, tlon, T_ALT, &p7, &p8, &p9);
    printf
      ("(scene demo_scene (parameters %f %f %f %f %f %f %f %f %f %f %f %f))\n",
       p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12);
    printf ("(update_scene UFOO (scene_id demo_scene))\n");
    printf ("(display_scene DFOO (scene_id demo_scene) (display_id DIS))\n\n");
  }
}
